/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints;

import edu.kit.ipd.descartes.core.AdaptableEntity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model Variable Configuration Range</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This adaptation point has a specific order, i.e., there exists a min and a max value with a discrete or continious value range. An example is the amount of VCPUs.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange#getAdaptableEntity <em>Adaptable Entity</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange#getMinValue <em>Min Value</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange#getMaxValue <em>Max Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getModelVariableConfigurationRange()
 * @model
 * @generated
 */
public interface ModelVariableConfigurationRange extends AdaptationPoint {
    /**
	 * Returns the value of the '<em><b>Adaptable Entity</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Adaptable Entity</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Adaptable Entity</em>' reference.
	 * @see #setAdaptableEntity(AdaptableEntity)
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getModelVariableConfigurationRange_AdaptableEntity()
	 * @model required="true"
	 * @generated
	 */
    AdaptableEntity getAdaptableEntity();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange#getAdaptableEntity <em>Adaptable Entity</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Adaptable Entity</em>' reference.
	 * @see #getAdaptableEntity()
	 * @generated
	 */
    void setAdaptableEntity(AdaptableEntity value);

    /**
	 * Returns the value of the '<em><b>Min Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Min Value</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Min Value</em>' attribute.
	 * @see #setMinValue(double)
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getModelVariableConfigurationRange_MinValue()
	 * @model required="true"
	 * @generated
	 */
    double getMinValue();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange#getMinValue <em>Min Value</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Value</em>' attribute.
	 * @see #getMinValue()
	 * @generated
	 */
    void setMinValue(double value);

    /**
	 * Returns the value of the '<em><b>Max Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Max Value</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Value</em>' attribute.
	 * @see #setMaxValue(double)
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getModelVariableConfigurationRange_MaxValue()
	 * @model required="true"
	 * @generated
	 */
    double getMaxValue();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange#getMaxValue <em>Max Value</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Value</em>' attribute.
	 * @see #getMaxValue()
	 * @generated
	 */
    void setMaxValue(double value);

} // ModelVariableConfigurationRange
