/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Property Range</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Use this entity to model variability of properties, e.g. the replication of a component. Min and max values of the range can be expressed in OCL constraints.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange#getMinValueConstraint <em>Min Value Constraint</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange#getMaxValueConstraint <em>Max Value Constraint</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getPropertyRange()
 * @model
 * @generated
 */
public interface PropertyRange extends VariationType {
    /**
	 * Returns the value of the '<em><b>Min Value Constraint</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Min Value Constraint</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Min Value Constraint</em>' containment reference.
	 * @see #setMinValueConstraint(OclConstraint)
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getPropertyRange_MinValueConstraint()
	 * @model containment="true" required="true"
	 * @generated
	 */
    OclConstraint getMinValueConstraint();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange#getMinValueConstraint <em>Min Value Constraint</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Value Constraint</em>' containment reference.
	 * @see #getMinValueConstraint()
	 * @generated
	 */
    void setMinValueConstraint(OclConstraint value);

    /**
	 * Returns the value of the '<em><b>Max Value Constraint</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Max Value Constraint</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Value Constraint</em>' containment reference.
	 * @see #setMaxValueConstraint(OclConstraint)
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#getPropertyRange_MaxValueConstraint()
	 * @model containment="true" required="true"
	 * @generated
	 */
    OclConstraint getMaxValueConstraint();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange#getMaxValueConstraint <em>Max Value Constraint</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Value Constraint</em>' containment reference.
	 * @see #getMaxValueConstraint()
	 * @generated
	 */
    void setMaxValueConstraint(OclConstraint value);

} // PropertyRange
