/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints.impl;

import edu.kit.ipd.descartes.core.AdaptableEntity;

import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage;
import edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model Variable Configuration Range</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.impl.ModelVariableConfigurationRangeImpl#getAdaptableEntity <em>Adaptable Entity</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.impl.ModelVariableConfigurationRangeImpl#getMinValue <em>Min Value</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptationpoints.impl.ModelVariableConfigurationRangeImpl#getMaxValue <em>Max Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ModelVariableConfigurationRangeImpl extends AdaptationPointImpl implements ModelVariableConfigurationRange {
    /**
	 * The cached value of the '{@link #getAdaptableEntity() <em>Adaptable Entity</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getAdaptableEntity()
	 * @generated
	 * @ordered
	 */
    protected AdaptableEntity adaptableEntity;

    /**
	 * The default value of the '{@link #getMinValue() <em>Min Value</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getMinValue()
	 * @generated
	 * @ordered
	 */
    protected static final double MIN_VALUE_EDEFAULT = 0.0;

    /**
	 * The cached value of the '{@link #getMinValue() <em>Min Value</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getMinValue()
	 * @generated
	 * @ordered
	 */
    protected double minValue = MIN_VALUE_EDEFAULT;

    /**
	 * The default value of the '{@link #getMaxValue() <em>Max Value</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getMaxValue()
	 * @generated
	 * @ordered
	 */
    protected static final double MAX_VALUE_EDEFAULT = 0.0;

    /**
	 * The cached value of the '{@link #getMaxValue() <em>Max Value</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getMaxValue()
	 * @generated
	 * @ordered
	 */
    protected double maxValue = MAX_VALUE_EDEFAULT;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ModelVariableConfigurationRangeImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return AdaptationpointsPackage.Literals.MODEL_VARIABLE_CONFIGURATION_RANGE;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptableEntity getAdaptableEntity() {
		if (adaptableEntity != null && adaptableEntity.eIsProxy()) {
			InternalEObject oldAdaptableEntity = (InternalEObject)adaptableEntity;
			adaptableEntity = (AdaptableEntity)eResolveProxy(oldAdaptableEntity);
			if (adaptableEntity != oldAdaptableEntity) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__ADAPTABLE_ENTITY, oldAdaptableEntity, adaptableEntity));
			}
		}
		return adaptableEntity;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptableEntity basicGetAdaptableEntity() {
		return adaptableEntity;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setAdaptableEntity(AdaptableEntity newAdaptableEntity) {
		AdaptableEntity oldAdaptableEntity = adaptableEntity;
		adaptableEntity = newAdaptableEntity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__ADAPTABLE_ENTITY, oldAdaptableEntity, adaptableEntity));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public double getMinValue() {
		return minValue;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setMinValue(double newMinValue) {
		double oldMinValue = minValue;
		minValue = newMinValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MIN_VALUE, oldMinValue, minValue));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public double getMaxValue() {
		return maxValue;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setMaxValue(double newMaxValue) {
		double oldMaxValue = maxValue;
		maxValue = newMaxValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MAX_VALUE, oldMaxValue, maxValue));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__ADAPTABLE_ENTITY:
				if (resolve) return getAdaptableEntity();
				return basicGetAdaptableEntity();
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MIN_VALUE:
				return getMinValue();
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MAX_VALUE:
				return getMaxValue();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__ADAPTABLE_ENTITY:
				setAdaptableEntity((AdaptableEntity)newValue);
				return;
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MIN_VALUE:
				setMinValue((Double)newValue);
				return;
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MAX_VALUE:
				setMaxValue((Double)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__ADAPTABLE_ENTITY:
				setAdaptableEntity((AdaptableEntity)null);
				return;
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MIN_VALUE:
				setMinValue(MIN_VALUE_EDEFAULT);
				return;
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MAX_VALUE:
				setMaxValue(MAX_VALUE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__ADAPTABLE_ENTITY:
				return adaptableEntity != null;
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MIN_VALUE:
				return minValue != MIN_VALUE_EDEFAULT;
			case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE__MAX_VALUE:
				return maxValue != MAX_VALUE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (minValue: ");
		result.append(minValue);
		result.append(", maxValue: ");
		result.append(maxValue);
		result.append(')');
		return result.toString();
	}

} //ModelVariableConfigurationRangeImpl
