/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints.util;

import edu.kit.ipd.descartes.core.Entity;
import edu.kit.ipd.descartes.core.NamedElement;

import edu.kit.ipd.descartes.identifier.Identifier;

import edu.kit.ipd.descartes.mm.adaptationpoints.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage
 * @generated
 */
public class AdaptationpointsAdapterFactory extends AdapterFactoryImpl {
    /**
	 * The cached model package.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected static AdaptationpointsPackage modelPackage;

    /**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptationpointsAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = AdaptationpointsPackage.eINSTANCE;
		}
	}

    /**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
     * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
     * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
    @Override
    public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

    /**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected AdaptationpointsSwitch<Adapter> modelSwitch =
        new AdaptationpointsSwitch<Adapter>() {
			@Override
			public Adapter caseAdaptationPointDescriptions(AdaptationPointDescriptions object) {
				return createAdaptationPointDescriptionsAdapter();
			}
			@Override
			public Adapter caseAdaptationPoint(AdaptationPoint object) {
				return createAdaptationPointAdapter();
			}
			@Override
			public Adapter caseModelVariableConfigurationRange(ModelVariableConfigurationRange object) {
				return createModelVariableConfigurationRangeAdapter();
			}
			@Override
			public Adapter caseModelEntityConfigurationRange(ModelEntityConfigurationRange object) {
				return createModelEntityConfigurationRangeAdapter();
			}
			@Override
			public Adapter caseVariationType(VariationType object) {
				return createVariationTypeAdapter();
			}
			@Override
			public Adapter casePropertyRange(PropertyRange object) {
				return createPropertyRangeAdapter();
			}
			@Override
			public Adapter caseSetOfConfigurations(SetOfConfigurations object) {
				return createSetOfConfigurationsAdapter();
			}
			@Override
			public Adapter caseOclConstraint(OclConstraint object) {
				return createOclConstraintAdapter();
			}
			@Override
			public Adapter caseIdentifier(Identifier object) {
				return createIdentifierAdapter();
			}
			@Override
			public Adapter caseNamedElement(NamedElement object) {
				return createNamedElementAdapter();
			}
			@Override
			public Adapter caseEntity(Entity object) {
				return createEntityAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

    /**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
    @Override
    public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPointDescriptions <em>Adaptation Point Descriptions</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPointDescriptions
	 * @generated
	 */
    public Adapter createAdaptationPointDescriptionsAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPoint <em>Adaptation Point</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPoint
	 * @generated
	 */
    public Adapter createAdaptationPointAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange <em>Model Variable Configuration Range</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange
	 * @generated
	 */
    public Adapter createModelVariableConfigurationRangeAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelEntityConfigurationRange <em>Model Entity Configuration Range</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.ModelEntityConfigurationRange
	 * @generated
	 */
    public Adapter createModelEntityConfigurationRangeAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.adaptationpoints.VariationType <em>Variation Type</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.VariationType
	 * @generated
	 */
    public Adapter createVariationTypeAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange <em>Property Range</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange
	 * @generated
	 */
    public Adapter createPropertyRangeAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations <em>Set Of Configurations</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations
	 * @generated
	 */
    public Adapter createSetOfConfigurationsAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.adaptationpoints.OclConstraint <em>Ocl Constraint</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.mm.adaptationpoints.OclConstraint
	 * @generated
	 */
    public Adapter createOclConstraintAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.identifier.Identifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.identifier.Identifier
	 * @generated
	 */
    public Adapter createIdentifierAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.core.NamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.core.NamedElement
	 * @generated
	 */
    public Adapter createNamedElementAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.core.Entity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see edu.kit.ipd.descartes.core.Entity
	 * @generated
	 */
    public Adapter createEntityAdapter() {
		return null;
	}

    /**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
     * This default implementation returns null.
     * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
    public Adapter createEObjectAdapter() {
		return null;
	}

} //AdaptationpointsAdapterFactory
