/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.provider;


import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesFactory;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ShadowParameter;
import edu.kit.ipd.descartes.mm.applicationlevel.util.CustomListenerComponent;
import java.util.Collection;
import java.util.List;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class DependencyPropagationRelationshipItemProvider extends RelationshipItemProvider {
	
	private CustomListenerComponent listenerComponent = new CustomListenerComponent(this);
	
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DependencyPropagationRelationshipItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addIndependentPropertyDescriptor(object);
			addDependentPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Independent feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIndependentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_DependencyPropagationRelationship_independent_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_DependencyPropagationRelationship_independent_feature", "_UI_DependencyPropagationRelationship_type"),
				 ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Dependent feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDependentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_DependencyPropagationRelationship_dependent_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_DependencyPropagationRelationship_dependent_feature", "_UI_DependencyPropagationRelationship_type"),
				 ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES);
			childrenFeatures.add(ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns DependencyPropagationRelationship.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/DependencyPropagationRelationship"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String getText(Object object) {
		DependencyPropagationRelationship dependencyPropagationRelationship = (DependencyPropagationRelationship)object;
		InfluencingParameter dependent = dependencyPropagationRelationship.getDependent();
		String label = getString("_UI_DependencyPropagationRelationship_type");
		
		if (dependencyPropagationRelationship.getDependent() != null) {
			updateListeners(dependencyPropagationRelationship, dependent);
			label += " " + getLabel(dependent);
		}
		return label;
	}
	
	private void updateListeners(DependencyPropagationRelationship dependencyPropagationRelationship,
			InfluencingParameter dependent) {
		listenerComponent.tryToUpdateListeners(dependencyPropagationRelationship, dependent);
		
		if (dependent instanceof CallParameter) {
			CallParameter cp = (CallParameter)dependent;
			if (cp.getParameter() != null)
				listenerComponent.tryToUpdateListeners(dependencyPropagationRelationship, cp.getParameter());
		}
	}
	
	
	private String getLabel(InfluencingParameter dependent) {
		if (dependent instanceof ShadowParameter) {
			ShadowParameter sp = (ShadowParameter)dependent;
			if (sp.getName() != null)
				return sp.getName();
			return "";
		}
		
		if (dependent instanceof CallParameter) {
			CallParameter cp = (CallParameter)dependent;
				if (cp.getParameter() != null && cp.getParameter().getName() != null)
					return cp.getParameter().getName();
		}
		
		throw new IllegalStateException("The metamodel seems to have changed, please "
				+ "update the getLabel(InfluencingParameter dependent) function of "
				+ "the DependencyPropagationRelationship");
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(DependencyPropagationRelationship.class)) {
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES:
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES,
				 ParameterdependenciesFactory.eINSTANCE.createComponentInstanceReference()));

		newChildDescriptors.add
			(createChildParameter
				(ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE,
				 ParameterdependenciesFactory.eINSTANCE.createComponentInstanceReference()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP__INDEPENDENT_COMPONENT_INSTANCE_REFERENCES ||
			childFeature == ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP__DEPENDENT_COMPONENT_INSTANCE_REFERENCE;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}
