/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.provider;


import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencableModelVariable;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.util.CustomListenerComponent;
import java.util.Collection;
import java.util.List;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;

/**
 * This is the item provider adapter for a {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class DependencyRelationshipItemProvider extends RelationshipItemProvider {
	
	private CustomListenerComponent listenerComponent =
			new CustomListenerComponent(this);
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DependencyRelationshipItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addDependentPropertyDescriptor(object);
			addIndependentPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Dependent feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDependentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_DependencyRelationship_dependent_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_DependencyRelationship_dependent_feature", "_UI_DependencyRelationship_type"),
				 ParameterdependenciesPackage.Literals.DEPENDENCY_RELATIONSHIP__DEPENDENT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Independent feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIndependentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_DependencyRelationship_independent_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_DependencyRelationship_independent_feature", "_UI_DependencyRelationship_type"),
				 ParameterdependenciesPackage.Literals.DEPENDENCY_RELATIONSHIP__INDEPENDENT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This returns DependencyRelationship.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/DependencyRelationship"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String getText(Object object) {
		DependencyRelationship dependencyRelationship = (DependencyRelationship)object;
		InfluencedVariableReference dependent = dependencyRelationship.getDependent();
		String label = getString("_UI_DependencyRelationship_type");
		
		if (dependent != null) {
			listenerComponent.tryToUpdateListeners(dependencyRelationship, dependent);
			if (dependent.getInfluencedVariable() != null)
				listenerComponent.tryToUpdateListeners(
						dependencyRelationship, dependent.getInfluencedVariable());
			if (dependent.getInfluencedVariable() != null) {
				InfluencableModelVariable influencedVariable = dependent.getInfluencedVariable();
				label += " " + influencedVariable.getName();
			}
		}
		return label;
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
