/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.provider;


import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencableModelVariable;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.BasicComponent;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.FineGrainedBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServiceBehaviorAbstraction;
import edu.kit.ipd.descartes.mm.applicationlevel.util.CustomListenerComponent;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencableModelVariable} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class InfluencableModelVariableItemProvider extends ModelVariableItemProvider {
	
	private CustomListenerComponent listenerComponent = new CustomListenerComponent(this);
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InfluencableModelVariableItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_InfluencableModelVariable_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_InfluencableModelVariable_name_feature", "_UI_InfluencableModelVariable_type"),
				 ParameterdependenciesPackage.Literals.INFLUENCABLE_MODEL_VARIABLE__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This returns InfluencableModelVariable.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/InfluencableModelVariable"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String getText(Object object) {
		updateListeners(object);
		String name = ((InfluencableModelVariable)object).getName();
		if (name != null && !name.trim().isEmpty()) {
			return name;
		}
		return "";
	}
	
	private void updateListeners(Object object) {
		ServiceBehaviorAbstraction behaviour = getParentBehaviour(object);
		listenerComponent.tryToUpdateListeners(object, behaviour);
		
		BasicComponent component = getParentComponent(object);
		listenerComponent.tryToUpdateListeners(object, component);
	}
	
	private BasicComponent getParentComponent(Object object) {
		Object parent = object;
		do {
			parent = getParent(parent);
		} while (!(parent instanceof BasicComponent));
		return (BasicComponent)parent;
	}

	private ServiceBehaviorAbstraction getParentBehaviour(Object object) {
		Object parent = object;
		do {
			parent = getParent(parent);
			if (parent instanceof ServiceBehaviorAbstraction)
				return (ServiceBehaviorAbstraction) parent;
		} while (!(parent instanceof BasicComponent));
		return null;
	}

	private String concatLabelPieces(String componentPartOfLabel,
			String behaviourNamePartOfLabel, String behaviourTypePartOfLabel,
			String namePartOfLabel) {
		String label = "";
		
		if (!componentPartOfLabel.isEmpty())
			label += componentPartOfLabel;
		if (!behaviourNamePartOfLabel.isEmpty())
			label += getSeperatorIfNeccesary(label) + behaviourNamePartOfLabel;
		if (!behaviourTypePartOfLabel.isEmpty())
			label += "(" + behaviourTypePartOfLabel + ")";
		if (!namePartOfLabel.isEmpty())
			label += getSeperatorIfNeccesary(label) + namePartOfLabel;
		return label;
	}

	private String getSeperatorIfNeccesary(String currentLabel) {
		if (!currentLabel.isEmpty())
			return "/";
		return "";
	}

	private String getNamePartOfLabel(String name) {
		if (name != null && !name.trim().isEmpty()) {
			return name;
		}
		return "";
	}

	private String getBehaviourNamePartOfLabel(ServiceBehaviorAbstraction behaviour) {
		if (behaviour != null && behaviour.getDescribedSignature() != null 
				&& behaviour.getDescribedSignature().getName() != null 
				&& !behaviour.getDescribedSignature().getName().trim().isEmpty()) {
			return behaviour.getDescribedSignature().getName();
		}
		return "";
	}
	private String getBehaviourTypePartOfLabel(ServiceBehaviorAbstraction behaviour) {
		if (behaviour != null && behaviour.getDescribedSignature() != null 
				&& behaviour.getDescribedSignature().getName() != null 
				&& !behaviour.getDescribedSignature().getName().trim().isEmpty()) {
			if (behaviour instanceof FineGrainedBehavior)
				return "Fine";
			if (behaviour instanceof CoarseGrainedBehavior)
				return "Coarse";
			if (behaviour instanceof BlackBoxBehavior)
				return "Black";
		}
		return "";
	}
	
	private String getComponentPartOfLabel(BasicComponent component) {
		if (component.getName() != null && !component.getName().trim().isEmpty())
			return component.getName();
		return "";
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(InfluencableModelVariable.class)) {
			case ParameterdependenciesPackage.INFLUENCABLE_MODEL_VARIABLE__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
