/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.provider;


import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ServiceInputParameter;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InputParamter;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServiceBehaviorAbstraction;
import edu.kit.ipd.descartes.mm.applicationlevel.util.CustomItemPropertyDescriptor;
import edu.kit.ipd.descartes.mm.applicationlevel.util.NavigationCommand;
import edu.kit.ipd.descartes.mm.applicationlevel.util.NavigationUtil;
import java.util.Collection;
import java.util.LinkedList;
import java.util.List;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;

/**
 * This is the item provider adapter for a {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ServiceInputParameter} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ServiceInputParameterItemProvider extends CallParameterItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServiceInputParameterItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addProvidingRolePropertyDescriptor(object);
			addParameterPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Providing Role feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addProvidingRolePropertyDescriptor(Object object) {
		NavigationCommand command = new NavigationCommand() {
			@Override
			public Collection<?> navigate(Object object) {
				ServiceInputParameter para = (ServiceInputParameter)object;
				ServiceBehaviorAbstraction behviour = para.getBehavior();
				if (behviour == null)
					return null;
				if (behviour.getInterfaceProvidingRole() == null)
					return null;
				List<Object> list = new LinkedList<Object>();
				list.add(behviour.getInterfaceProvidingRole());
				return list;
			}
		};
		itemPropertyDescriptors.add
			(new CustomItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ServiceInputParameter_providingRole_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ServiceInputParameter_providingRole_feature", "_UI_ServiceInputParameter_type"),
				 ParameterdependenciesPackage.Literals.SERVICE_INPUT_PARAMETER__PROVIDING_ROLE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null, 
				 command));
	}

	/**
	 * This adds a property descriptor for the Parameter feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addParameterPropertyDescriptor(Object object) {
		NavigationCommand command = new NavigationCommand() {
			@Override
			public Collection<?> navigate(Object object) {
				ServiceInputParameter para = (ServiceInputParameter)object;
				ServiceBehaviorAbstraction behaviour = (ServiceBehaviorAbstraction)getParent(para);
				if (behaviour.getDescribedSignature() == null)
					return null;
				List<Object> filteredList = NavigationUtil.getObjectsWithClass(
						behaviour.getDescribedSignature().getParameters(), InputParamter.class);
				return filteredList;
			}
		};
		itemPropertyDescriptors.add
			(new CustomItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ServiceInputParameter_parameter_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ServiceInputParameter_parameter_feature", "_UI_ServiceInputParameter_type"),
				 ParameterdependenciesPackage.Literals.SERVICE_INPUT_PARAMETER__PARAMETER,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null,
				 command));
	}

	/**
	 * This returns ServiceInputParameter.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ServiceInputParameter"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String getText(Object object) {
			return getString("_UI_ServiceInputParameter_type") + super.getText(object);
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
