/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.provider;


import edu.kit.ipd.descartes.core.provider.EntityItemProvider;
import edu.kit.ipd.descartes.mm.applicationlevel.provider.ApplicationlevelEditPlugin;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.BasicComponent;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceRequiringRole;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.util.CustomItemPropertyDescriptor;
import edu.kit.ipd.descartes.mm.applicationlevel.util.NavigationCommand;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;

/**
 * This is the item provider adapter for a {@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ExternalCallItemProvider 
	extends EntityItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExternalCallItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addSignaturePropertyDescriptor(object);
			addInterfaceRequiringRolePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Signature feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addSignaturePropertyDescriptor(Object object) {
		NavigationCommand command = new NavigationCommand() {
				@Override
				public Collection<?> navigate(Object object) {
					ExternalCall call = (ExternalCall)object;
					InterfaceRequiringRole interReq = call.getInterfaceRequiringRole();
					if (interReq == null)
						return null;
					Interface inface = interReq.getInterface();
					if (inface == null)
						return null;
					return inface.getSignatures();
				}
		};
		itemPropertyDescriptors.add
			(new CustomItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ExternalCall_signature_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ExternalCall_signature_feature", "_UI_ExternalCall_type"),					 ServicebehaviorPackage.Literals.EXTERNAL_CALL__SIGNATURE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null, 
				 command));
	}

	/**
	 * This adds a property descriptor for the Interface Requiring Role feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addInterfaceRequiringRolePropertyDescriptor(Object object) {
		NavigationCommand command = new NavigationCommand() {
			@Override
			public Collection<?> navigate(Object object) {
				ExternalCall call = (ExternalCall)object;
				Object parent = call;
				while (!(parent instanceof BasicComponent))
					parent = getParent(parent);
				BasicComponent basicComponent = (BasicComponent) parent;
				List<InterfaceRequiringRole> interfaceReqiringRoles = basicComponent.getInterfaceRequiringRoles();
				return interfaceReqiringRoles;
			}
		};
		itemPropertyDescriptors.add
			(new CustomItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ExternalCall_interfaceRequiringRole_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ExternalCall_interfaceRequiringRole_feature", "_UI_ExternalCall_type"),
				 ServicebehaviorPackage.Literals.EXTERNAL_CALL__INTERFACE_REQUIRING_ROLE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null,
				 command));
	}

	/**
	 * This returns ExternalCall.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ExternalCall"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((ExternalCall)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_ExternalCall_type") :
			getString("_UI_ExternalCall_type") + " " + label;
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return ApplicationlevelEditPlugin.INSTANCE;
	}

}
