package edu.kit.ipd.descartes.mm.applicationlevel.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;

public class CustomItemPropertyDescriptor extends ItemPropertyDescriptor {
	private NavigationCommand command;
	
	public CustomItemPropertyDescriptor
	(AdapterFactory adapterFactory,
     ResourceLocator resourceLocator,
     String displayName,
     String description,
     EStructuralFeature feature, 
     boolean isSettable,
     boolean multiLine,
     boolean sortChoices,
     Object staticImage,
     String category,
     String [] filterFlags,
     NavigationCommand command)
	 {
			super
		     (adapterFactory,
		      resourceLocator,
		      displayName,
		      description,
		      feature, 
		      isSettable,
		      multiLine,
		      sortChoices,
		      staticImage,
		      category,
		      filterFlags);;
		   this.command = command;
	 }
	
	@Override
	public Collection<?> getComboBoxObjects(Object object) {
		Collection<?> result = command.navigate(object);
		if (result == null || result.size() == 0)
			return super.getComboBoxObjects(object);
		
		List<Object> comboBoxObjects = new ArrayList<Object>(result.size() + 1);
		comboBoxObjects.addAll(result);
		comboBoxObjects.add(null);
		return comboBoxObjects;
	}
}
