/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.functions;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.FunctionsFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import ecore_0='http://www.eclipse.org/emf/2002/Ecore' repository_0='repository.ecore#/'"
 * @generated
 */
public interface FunctionsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "functions";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes-research.net/metamodel/functions/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "functions";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FunctionsPackage eINSTANCE = edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExpressionImpl <em>Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExpressionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getExpression()
	 * @generated
	 */
	int EXPRESSION = 0;

	/**
	 * The number of structural features of the '<em>Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExplicitDescriptionImpl <em>Explicit Description</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExplicitDescriptionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getExplicitDescription()
	 * @generated
	 */
	int EXPLICIT_DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DESCRIPTION__EXPRESSION = 0;

	/**
	 * The number of structural features of the '<em>Explicit Description</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLICIT_DESCRIPTION_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.AtomImpl <em>Atom</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.AtomImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getAtom()
	 * @generated
	 */
	int ATOM = 4;

	/**
	 * The number of structural features of the '<em>Atom</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATOM_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionImpl <em>Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getFunction()
	 * @generated
	 */
	int FUNCTION = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__NAME = ATOM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__PARAMETERS = ATOM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_FEATURE_COUNT = ATOM_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FormalParameterImpl <em>Formal Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FormalParameterImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getFormalParameter()
	 * @generated
	 */
	int FORMAL_PARAMETER = 3;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORMAL_PARAMETER__VALUE = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Formal Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORMAL_PARAMETER_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IfElseExpressionImpl <em>If Else Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IfElseExpressionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getIfElseExpression()
	 * @generated
	 */
	int IF_ELSE_EXPRESSION = 5;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_ELSE_EXPRESSION__CONDITION = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>True Exp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_ELSE_EXPRESSION__TRUE_EXP = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>False Exp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_ELSE_EXPRESSION__FALSE_EXP = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>If Else Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_ELSE_EXPRESSION_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BinaryBooleanExpressionImpl <em>Binary Boolean Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BinaryBooleanExpressionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBinaryBooleanExpression()
	 * @generated
	 */
	int BINARY_BOOLEAN_EXPRESSION = 6;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_BOOLEAN_EXPRESSION__LEFT = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Operation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_BOOLEAN_EXPRESSION__OPERATION = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_BOOLEAN_EXPRESSION__RIGHT = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Binary Boolean Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_BOOLEAN_EXPRESSION_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.UnaryBooleanExpressionImpl <em>Unary Boolean Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.UnaryBooleanExpressionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getUnaryBooleanExpression()
	 * @generated
	 */
	int UNARY_BOOLEAN_EXPRESSION = 7;

	/**
	 * The feature id for the '<em><b>Inner</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_BOOLEAN_EXPRESSION__INNER = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Unary Boolean Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_BOOLEAN_EXPRESSION_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ComparisonImpl <em>Comparison</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ComparisonImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getComparison()
	 * @generated
	 */
	int COMPARISON = 8;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON__LEFT = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Operation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON__OPERATION = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON__RIGHT = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Comparison</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.TermImpl <em>Term</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.TermImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getTerm()
	 * @generated
	 */
	int TERM = 9;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERM__LEFT = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Operation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERM__OPERATION = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERM__RIGHT = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Term</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERM_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProductImpl <em>Product</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProductImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProduct()
	 * @generated
	 */
	int PRODUCT = 10;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT__LEFT = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Operation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT__OPERATION = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT__RIGHT = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Product</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.PowerImpl <em>Power</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.PowerImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getPower()
	 * @generated
	 */
	int POWER = 11;

	/**
	 * The feature id for the '<em><b>Base</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER__BASE = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Exponent</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER__EXPONENT = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Power</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.RandomVariableImpl <em>Random Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.RandomVariableImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getRandomVariable()
	 * @generated
	 */
	int RANDOM_VARIABLE = 12;

	/**
	 * The feature id for the '<em><b>Prob Function</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE__PROB_FUNCTION = 0;

	/**
	 * The number of structural features of the '<em>Random Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RANDOM_VARIABLE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityFunctionImpl <em>Probability Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityFunctionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProbabilityFunction()
	 * @generated
	 */
	int PROBABILITY_FUNCTION = 13;

	/**
	 * The number of structural features of the '<em>Probability Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_FUNCTION_FEATURE_COUNT = ATOM_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.LiteralImpl <em>Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.LiteralImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getLiteral()
	 * @generated
	 */
	int LITERAL = 14;

	/**
	 * The number of structural features of the '<em>Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_FEATURE_COUNT = PROBABILITY_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BooleanLiteralImpl <em>Boolean Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BooleanLiteralImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBooleanLiteral()
	 * @generated
	 */
	int BOOLEAN_LITERAL = 15;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_LITERAL__VALUE = LITERAL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Boolean Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_LITERAL_FEATURE_COUNT = LITERAL_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntLiteralImpl <em>Int Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntLiteralImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getIntLiteral()
	 * @generated
	 */
	int INT_LITERAL = 16;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_LITERAL__VALUE = LITERAL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Int Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_LITERAL_FEATURE_COUNT = LITERAL_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleLiteralImpl <em>Double Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleLiteralImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getDoubleLiteral()
	 * @generated
	 */
	int DOUBLE_LITERAL = 17;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_LITERAL__VALUE = LITERAL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Double Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_LITERAL_FEATURE_COUNT = LITERAL_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityMassFunctionImpl <em>Probability Mass Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityMassFunctionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProbabilityMassFunction()
	 * @generated
	 */
	int PROBABILITY_MASS_FUNCTION = 18;

	/**
	 * The feature id for the '<em><b>Samples</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_MASS_FUNCTION__SAMPLES = PROBABILITY_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Probability Mass Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_MASS_FUNCTION_FEATURE_COUNT = PROBABILITY_FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.SampleListImpl <em>Sample List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.SampleListImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getSampleList()
	 * @generated
	 */
	int SAMPLE_LIST = 19;

	/**
	 * The number of structural features of the '<em>Sample List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLE_LIST_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.SampleImpl <em>Sample</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.SampleImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getSample()
	 * @generated
	 */
	int SAMPLE = 20;

	/**
	 * The number of structural features of the '<em>Sample</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAMPLE_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleSampleImpl <em>Double Sample</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleSampleImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getDoubleSample()
	 * @generated
	 */
	int DOUBLE_SAMPLE = 21;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SAMPLE__VALUE = SAMPLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SAMPLE__PROBABILITY = SAMPLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Double Sample</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SAMPLE_FEATURE_COUNT = SAMPLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntSampleImpl <em>Int Sample</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntSampleImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getIntSample()
	 * @generated
	 */
	int INT_SAMPLE = 22;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_SAMPLE__VALUE = SAMPLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_SAMPLE__PROBABILITY = SAMPLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Int Sample</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_SAMPLE_FEATURE_COUNT = SAMPLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoolSampleImpl <em>Bool Sample</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoolSampleImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBoolSample()
	 * @generated
	 */
	int BOOL_SAMPLE = 23;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_SAMPLE__VALUE = SAMPLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_SAMPLE__PROBABILITY = SAMPLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Bool Sample</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_SAMPLE_FEATURE_COUNT = SAMPLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.EnumSampleImpl <em>Enum Sample</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.EnumSampleImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getEnumSample()
	 * @generated
	 */
	int ENUM_SAMPLE = 24;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_SAMPLE__VALUE = SAMPLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_SAMPLE__PROBABILITY = SAMPLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Enum Sample</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_SAMPLE_FEATURE_COUNT = SAMPLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntSampleListImpl <em>Int Sample List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntSampleListImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getIntSampleList()
	 * @generated
	 */
	int INT_SAMPLE_LIST = 25;

	/**
	 * The feature id for the '<em><b>Items</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_SAMPLE_LIST__ITEMS = SAMPLE_LIST_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Int Sample List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_SAMPLE_LIST_FEATURE_COUNT = SAMPLE_LIST_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleSampleListImpl <em>Double Sample List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleSampleListImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getDoubleSampleList()
	 * @generated
	 */
	int DOUBLE_SAMPLE_LIST = 26;

	/**
	 * The feature id for the '<em><b>Items</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SAMPLE_LIST__ITEMS = SAMPLE_LIST_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Double Sample List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_SAMPLE_LIST_FEATURE_COUNT = SAMPLE_LIST_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoolSampleListImpl <em>Bool Sample List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoolSampleListImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBoolSampleList()
	 * @generated
	 */
	int BOOL_SAMPLE_LIST = 27;

	/**
	 * The feature id for the '<em><b>Items</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_SAMPLE_LIST__ITEMS = SAMPLE_LIST_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Bool Sample List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_SAMPLE_LIST_FEATURE_COUNT = SAMPLE_LIST_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.EnumSampleListImpl <em>Enum Sample List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.EnumSampleListImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getEnumSampleList()
	 * @generated
	 */
	int ENUM_SAMPLE_LIST = 28;

	/**
	 * The feature id for the '<em><b>Items</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_SAMPLE_LIST__ITEMS = SAMPLE_LIST_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Enum Sample List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUM_SAMPLE_LIST_FEATURE_COUNT = SAMPLE_LIST_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityDensityFunctionImpl <em>Probability Density Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityDensityFunctionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProbabilityDensityFunction()
	 * @generated
	 */
	int PROBABILITY_DENSITY_FUNCTION = 29;

	/**
	 * The number of structural features of the '<em>Probability Density Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_DENSITY_FUNCTION_FEATURE_COUNT = PROBABILITY_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoxedPDFImpl <em>Boxed PDF</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoxedPDFImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBoxedPDF()
	 * @generated
	 */
	int BOXED_PDF = 30;

	/**
	 * The feature id for the '<em><b>Sample</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOXED_PDF__SAMPLE = PROBABILITY_DENSITY_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Boxed PDF</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOXED_PDF_FEATURE_COUNT = PROBABILITY_DENSITY_FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ContinuousSampleImpl <em>Continuous Sample</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ContinuousSampleImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getContinuousSample()
	 * @generated
	 */
	int CONTINUOUS_SAMPLE = 31;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_SAMPLE__VALUE = 0;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_SAMPLE__PROBABILITY = 1;

	/**
	 * The number of structural features of the '<em>Continuous Sample</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_SAMPLE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ContinuousPDFImpl <em>Continuous PDF</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ContinuousPDFImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getContinuousPDF()
	 * @generated
	 */
	int CONTINUOUS_PDF = 32;

	/**
	 * The number of structural features of the '<em>Continuous PDF</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_PDF_FEATURE_COUNT = PROBABILITY_DENSITY_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.NormalDistributionImpl <em>Normal Distribution</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.NormalDistributionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getNormalDistribution()
	 * @generated
	 */
	int NORMAL_DISTRIBUTION = 33;

	/**
	 * The feature id for the '<em><b>Mu</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NORMAL_DISTRIBUTION__MU = CONTINUOUS_PDF_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Sigma</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NORMAL_DISTRIBUTION__SIGMA = CONTINUOUS_PDF_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Normal Distribution</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NORMAL_DISTRIBUTION_FEATURE_COUNT = CONTINUOUS_PDF_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExponentialDistributionImpl <em>Exponential Distribution</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExponentialDistributionImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getExponentialDistribution()
	 * @generated
	 */
	int EXPONENTIAL_DISTRIBUTION = 34;

	/**
	 * The feature id for the '<em><b>Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_DISTRIBUTION__RATE = CONTINUOUS_PDF_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Exponential Distribution</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPONENTIAL_DISTRIBUTION_FEATURE_COUNT = CONTINUOUS_PDF_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ProductOperation <em>Product Operation</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ProductOperation
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProductOperation()
	 * @generated
	 */
	int PRODUCT_OPERATION = 35;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.TermOperation <em>Term Operation</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.TermOperation
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getTermOperation()
	 * @generated
	 */
	int TERM_OPERATION = 36;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.CompareOperation <em>Compare Operation</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.CompareOperation
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getCompareOperation()
	 * @generated
	 */
	int COMPARE_OPERATION = 37;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanOperation <em>Boolean Operation</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanOperation
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBooleanOperation()
	 * @generated
	 */
	int BOOLEAN_OPERATION = 38;


	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Expression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expression</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Expression
	 * @generated
	 */
	EClass getExpression();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription <em>Explicit Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Explicit Description</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription
	 * @generated
	 */
	EClass getExplicitDescription();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expression</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription#getExpression()
	 * @see #getExplicitDescription()
	 * @generated
	 */
	EReference getExplicitDescription_Expression();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Function <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Function</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Function
	 * @generated
	 */
	EClass getFunction();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Function#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Function#getName()
	 * @see #getFunction()
	 * @generated
	 */
	EAttribute getFunction_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Function#getParameters <em>Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Parameters</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Function#getParameters()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_Parameters();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.FormalParameter <em>Formal Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Formal Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.FormalParameter
	 * @generated
	 */
	EClass getFormalParameter();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.FormalParameter#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.FormalParameter#getValue()
	 * @see #getFormalParameter()
	 * @generated
	 */
	EAttribute getFormalParameter_Value();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Atom <em>Atom</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Atom</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Atom
	 * @generated
	 */
	EClass getAtom();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression <em>If Else Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>If Else Expression</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression
	 * @generated
	 */
	EClass getIfElseExpression();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Condition</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression#getCondition()
	 * @see #getIfElseExpression()
	 * @generated
	 */
	EReference getIfElseExpression_Condition();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression#getTrueExp <em>True Exp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>True Exp</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression#getTrueExp()
	 * @see #getIfElseExpression()
	 * @generated
	 */
	EReference getIfElseExpression_TrueExp();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression#getFalseExp <em>False Exp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>False Exp</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression#getFalseExp()
	 * @see #getIfElseExpression()
	 * @generated
	 */
	EReference getIfElseExpression_FalseExp();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression <em>Binary Boolean Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Boolean Expression</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression
	 * @generated
	 */
	EClass getBinaryBooleanExpression();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression#getLeft <em>Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Left</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression#getLeft()
	 * @see #getBinaryBooleanExpression()
	 * @generated
	 */
	EReference getBinaryBooleanExpression_Left();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression#getOperation <em>Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression#getOperation()
	 * @see #getBinaryBooleanExpression()
	 * @generated
	 */
	EAttribute getBinaryBooleanExpression_Operation();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression#getRight <em>Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Right</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression#getRight()
	 * @see #getBinaryBooleanExpression()
	 * @generated
	 */
	EReference getBinaryBooleanExpression_Right();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.UnaryBooleanExpression <em>Unary Boolean Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Boolean Expression</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.UnaryBooleanExpression
	 * @generated
	 */
	EClass getUnaryBooleanExpression();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.UnaryBooleanExpression#getInner <em>Inner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Inner</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.UnaryBooleanExpression#getInner()
	 * @see #getUnaryBooleanExpression()
	 * @generated
	 */
	EReference getUnaryBooleanExpression_Inner();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Comparison <em>Comparison</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comparison</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Comparison
	 * @generated
	 */
	EClass getComparison();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Comparison#getLeft <em>Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Left</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Comparison#getLeft()
	 * @see #getComparison()
	 * @generated
	 */
	EReference getComparison_Left();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Comparison#getOperation <em>Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Comparison#getOperation()
	 * @see #getComparison()
	 * @generated
	 */
	EAttribute getComparison_Operation();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Comparison#getRight <em>Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Right</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Comparison#getRight()
	 * @see #getComparison()
	 * @generated
	 */
	EReference getComparison_Right();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Term <em>Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Term</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Term
	 * @generated
	 */
	EClass getTerm();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Term#getLeft <em>Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Left</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Term#getLeft()
	 * @see #getTerm()
	 * @generated
	 */
	EReference getTerm_Left();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Term#getOperation <em>Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Term#getOperation()
	 * @see #getTerm()
	 * @generated
	 */
	EAttribute getTerm_Operation();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Term#getRight <em>Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Right</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Term#getRight()
	 * @see #getTerm()
	 * @generated
	 */
	EReference getTerm_Right();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Product <em>Product</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Product</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Product
	 * @generated
	 */
	EClass getProduct();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Product#getLeft <em>Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Left</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Product#getLeft()
	 * @see #getProduct()
	 * @generated
	 */
	EReference getProduct_Left();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Product#getOperation <em>Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Product#getOperation()
	 * @see #getProduct()
	 * @generated
	 */
	EAttribute getProduct_Operation();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Product#getRight <em>Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Right</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Product#getRight()
	 * @see #getProduct()
	 * @generated
	 */
	EReference getProduct_Right();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Power <em>Power</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Power</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Power
	 * @generated
	 */
	EClass getPower();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Power#getBase <em>Base</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Base</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Power#getBase()
	 * @see #getPower()
	 * @generated
	 */
	EReference getPower_Base();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Power#getExponent <em>Exponent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Exponent</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Power#getExponent()
	 * @see #getPower()
	 * @generated
	 */
	EReference getPower_Exponent();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable <em>Random Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Random Variable</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable
	 * @generated
	 */
	EClass getRandomVariable();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable#getProbFunction <em>Prob Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Prob Function</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable#getProbFunction()
	 * @see #getRandomVariable()
	 * @generated
	 */
	EReference getRandomVariable_ProbFunction();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ProbabilityFunction <em>Probability Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Probability Function</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ProbabilityFunction
	 * @generated
	 */
	EClass getProbabilityFunction();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Literal <em>Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Literal</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Literal
	 * @generated
	 */
	EClass getLiteral();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanLiteral <em>Boolean Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Boolean Literal</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanLiteral
	 * @generated
	 */
	EClass getBooleanLiteral();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanLiteral#isValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanLiteral#isValue()
	 * @see #getBooleanLiteral()
	 * @generated
	 */
	EAttribute getBooleanLiteral_Value();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IntLiteral <em>Int Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Int Literal</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IntLiteral
	 * @generated
	 */
	EClass getIntLiteral();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IntLiteral#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IntLiteral#getValue()
	 * @see #getIntLiteral()
	 * @generated
	 */
	EAttribute getIntLiteral_Value();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleLiteral <em>Double Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Double Literal</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleLiteral
	 * @generated
	 */
	EClass getDoubleLiteral();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleLiteral#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleLiteral#getValue()
	 * @see #getDoubleLiteral()
	 * @generated
	 */
	EAttribute getDoubleLiteral_Value();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ProbabilityMassFunction <em>Probability Mass Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Probability Mass Function</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ProbabilityMassFunction
	 * @generated
	 */
	EClass getProbabilityMassFunction();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ProbabilityMassFunction#getSamples <em>Samples</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Samples</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ProbabilityMassFunction#getSamples()
	 * @see #getProbabilityMassFunction()
	 * @generated
	 */
	EReference getProbabilityMassFunction_Samples();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.SampleList <em>Sample List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sample List</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.SampleList
	 * @generated
	 */
	EClass getSampleList();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.Sample <em>Sample</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sample</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.Sample
	 * @generated
	 */
	EClass getSample();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSample <em>Double Sample</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Double Sample</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSample
	 * @generated
	 */
	EClass getDoubleSample();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSample#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSample#getValue()
	 * @see #getDoubleSample()
	 * @generated
	 */
	EAttribute getDoubleSample_Value();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSample#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSample#getProbability()
	 * @see #getDoubleSample()
	 * @generated
	 */
	EAttribute getDoubleSample_Probability();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSample <em>Int Sample</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Int Sample</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSample
	 * @generated
	 */
	EClass getIntSample();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSample#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSample#getValue()
	 * @see #getIntSample()
	 * @generated
	 */
	EAttribute getIntSample_Value();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSample#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSample#getProbability()
	 * @see #getIntSample()
	 * @generated
	 */
	EAttribute getIntSample_Probability();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSample <em>Bool Sample</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bool Sample</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSample
	 * @generated
	 */
	EClass getBoolSample();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSample#isValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSample#isValue()
	 * @see #getBoolSample()
	 * @generated
	 */
	EAttribute getBoolSample_Value();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSample#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSample#getProbability()
	 * @see #getBoolSample()
	 * @generated
	 */
	EAttribute getBoolSample_Probability();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSample <em>Enum Sample</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enum Sample</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSample
	 * @generated
	 */
	EClass getEnumSample();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSample#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSample#getValue()
	 * @see #getEnumSample()
	 * @generated
	 */
	EAttribute getEnumSample_Value();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSample#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSample#getProbability()
	 * @see #getEnumSample()
	 * @generated
	 */
	EAttribute getEnumSample_Probability();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSampleList <em>Int Sample List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Int Sample List</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSampleList
	 * @generated
	 */
	EClass getIntSampleList();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSampleList#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Items</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.IntSampleList#getItems()
	 * @see #getIntSampleList()
	 * @generated
	 */
	EReference getIntSampleList_Items();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSampleList <em>Double Sample List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Double Sample List</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSampleList
	 * @generated
	 */
	EClass getDoubleSampleList();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSampleList#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Items</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.DoubleSampleList#getItems()
	 * @see #getDoubleSampleList()
	 * @generated
	 */
	EReference getDoubleSampleList_Items();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSampleList <em>Bool Sample List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bool Sample List</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSampleList
	 * @generated
	 */
	EClass getBoolSampleList();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSampleList#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Items</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BoolSampleList#getItems()
	 * @see #getBoolSampleList()
	 * @generated
	 */
	EReference getBoolSampleList_Items();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSampleList <em>Enum Sample List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enum Sample List</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSampleList
	 * @generated
	 */
	EClass getEnumSampleList();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSampleList#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Items</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.EnumSampleList#getItems()
	 * @see #getEnumSampleList()
	 * @generated
	 */
	EReference getEnumSampleList_Items();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ProbabilityDensityFunction <em>Probability Density Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Probability Density Function</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ProbabilityDensityFunction
	 * @generated
	 */
	EClass getProbabilityDensityFunction();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BoxedPDF <em>Boxed PDF</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Boxed PDF</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BoxedPDF
	 * @generated
	 */
	EClass getBoxedPDF();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BoxedPDF#getSample <em>Sample</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sample</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BoxedPDF#getSample()
	 * @see #getBoxedPDF()
	 * @generated
	 */
	EReference getBoxedPDF_Sample();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ContinuousSample <em>Continuous Sample</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Continuous Sample</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ContinuousSample
	 * @generated
	 */
	EClass getContinuousSample();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ContinuousSample#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ContinuousSample#getValue()
	 * @see #getContinuousSample()
	 * @generated
	 */
	EAttribute getContinuousSample_Value();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ContinuousSample#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ContinuousSample#getProbability()
	 * @see #getContinuousSample()
	 * @generated
	 */
	EAttribute getContinuousSample_Probability();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ContinuousPDF <em>Continuous PDF</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Continuous PDF</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ContinuousPDF
	 * @generated
	 */
	EClass getContinuousPDF();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.NormalDistribution <em>Normal Distribution</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Normal Distribution</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.NormalDistribution
	 * @generated
	 */
	EClass getNormalDistribution();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.NormalDistribution#getMu <em>Mu</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mu</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.NormalDistribution#getMu()
	 * @see #getNormalDistribution()
	 * @generated
	 */
	EAttribute getNormalDistribution_Mu();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.NormalDistribution#getSigma <em>Sigma</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sigma</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.NormalDistribution#getSigma()
	 * @see #getNormalDistribution()
	 * @generated
	 */
	EAttribute getNormalDistribution_Sigma();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ExponentialDistribution <em>Exponential Distribution</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exponential Distribution</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ExponentialDistribution
	 * @generated
	 */
	EClass getExponentialDistribution();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ExponentialDistribution#getRate <em>Rate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rate</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ExponentialDistribution#getRate()
	 * @see #getExponentialDistribution()
	 * @generated
	 */
	EAttribute getExponentialDistribution_Rate();

	/**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ProductOperation <em>Product Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Product Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ProductOperation
	 * @generated
	 */
	EEnum getProductOperation();

	/**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.TermOperation <em>Term Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Term Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.TermOperation
	 * @generated
	 */
	EEnum getTermOperation();

	/**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.CompareOperation <em>Compare Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Compare Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.CompareOperation
	 * @generated
	 */
	EEnum getCompareOperation();

	/**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanOperation <em>Boolean Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Boolean Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanOperation
	 * @generated
	 */
	EEnum getBooleanOperation();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FunctionsFactory getFunctionsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExpressionImpl <em>Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExpressionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getExpression()
		 * @generated
		 */
		EClass EXPRESSION = eINSTANCE.getExpression();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExplicitDescriptionImpl <em>Explicit Description</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExplicitDescriptionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getExplicitDescription()
		 * @generated
		 */
		EClass EXPLICIT_DESCRIPTION = eINSTANCE.getExplicitDescription();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPLICIT_DESCRIPTION__EXPRESSION = eINSTANCE.getExplicitDescription_Expression();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionImpl <em>Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getFunction()
		 * @generated
		 */
		EClass FUNCTION = eINSTANCE.getFunction();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FUNCTION__NAME = eINSTANCE.getFunction_Name();

		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FUNCTION__PARAMETERS = eINSTANCE.getFunction_Parameters();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FormalParameterImpl <em>Formal Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FormalParameterImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getFormalParameter()
		 * @generated
		 */
		EClass FORMAL_PARAMETER = eINSTANCE.getFormalParameter();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FORMAL_PARAMETER__VALUE = eINSTANCE.getFormalParameter_Value();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.AtomImpl <em>Atom</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.AtomImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getAtom()
		 * @generated
		 */
		EClass ATOM = eINSTANCE.getAtom();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IfElseExpressionImpl <em>If Else Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IfElseExpressionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getIfElseExpression()
		 * @generated
		 */
		EClass IF_ELSE_EXPRESSION = eINSTANCE.getIfElseExpression();

		/**
		 * The meta object literal for the '<em><b>Condition</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IF_ELSE_EXPRESSION__CONDITION = eINSTANCE.getIfElseExpression_Condition();

		/**
		 * The meta object literal for the '<em><b>True Exp</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IF_ELSE_EXPRESSION__TRUE_EXP = eINSTANCE.getIfElseExpression_TrueExp();

		/**
		 * The meta object literal for the '<em><b>False Exp</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IF_ELSE_EXPRESSION__FALSE_EXP = eINSTANCE.getIfElseExpression_FalseExp();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BinaryBooleanExpressionImpl <em>Binary Boolean Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BinaryBooleanExpressionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBinaryBooleanExpression()
		 * @generated
		 */
		EClass BINARY_BOOLEAN_EXPRESSION = eINSTANCE.getBinaryBooleanExpression();

		/**
		 * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_BOOLEAN_EXPRESSION__LEFT = eINSTANCE.getBinaryBooleanExpression_Left();

		/**
		 * The meta object literal for the '<em><b>Operation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BINARY_BOOLEAN_EXPRESSION__OPERATION = eINSTANCE.getBinaryBooleanExpression_Operation();

		/**
		 * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_BOOLEAN_EXPRESSION__RIGHT = eINSTANCE.getBinaryBooleanExpression_Right();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.UnaryBooleanExpressionImpl <em>Unary Boolean Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.UnaryBooleanExpressionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getUnaryBooleanExpression()
		 * @generated
		 */
		EClass UNARY_BOOLEAN_EXPRESSION = eINSTANCE.getUnaryBooleanExpression();

		/**
		 * The meta object literal for the '<em><b>Inner</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNARY_BOOLEAN_EXPRESSION__INNER = eINSTANCE.getUnaryBooleanExpression_Inner();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ComparisonImpl <em>Comparison</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ComparisonImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getComparison()
		 * @generated
		 */
		EClass COMPARISON = eINSTANCE.getComparison();

		/**
		 * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPARISON__LEFT = eINSTANCE.getComparison_Left();

		/**
		 * The meta object literal for the '<em><b>Operation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPARISON__OPERATION = eINSTANCE.getComparison_Operation();

		/**
		 * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPARISON__RIGHT = eINSTANCE.getComparison_Right();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.TermImpl <em>Term</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.TermImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getTerm()
		 * @generated
		 */
		EClass TERM = eINSTANCE.getTerm();

		/**
		 * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TERM__LEFT = eINSTANCE.getTerm_Left();

		/**
		 * The meta object literal for the '<em><b>Operation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TERM__OPERATION = eINSTANCE.getTerm_Operation();

		/**
		 * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TERM__RIGHT = eINSTANCE.getTerm_Right();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProductImpl <em>Product</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProductImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProduct()
		 * @generated
		 */
		EClass PRODUCT = eINSTANCE.getProduct();

		/**
		 * The meta object literal for the '<em><b>Left</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PRODUCT__LEFT = eINSTANCE.getProduct_Left();

		/**
		 * The meta object literal for the '<em><b>Operation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PRODUCT__OPERATION = eINSTANCE.getProduct_Operation();

		/**
		 * The meta object literal for the '<em><b>Right</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PRODUCT__RIGHT = eINSTANCE.getProduct_Right();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.PowerImpl <em>Power</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.PowerImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getPower()
		 * @generated
		 */
		EClass POWER = eINSTANCE.getPower();

		/**
		 * The meta object literal for the '<em><b>Base</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference POWER__BASE = eINSTANCE.getPower_Base();

		/**
		 * The meta object literal for the '<em><b>Exponent</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference POWER__EXPONENT = eINSTANCE.getPower_Exponent();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.RandomVariableImpl <em>Random Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.RandomVariableImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getRandomVariable()
		 * @generated
		 */
		EClass RANDOM_VARIABLE = eINSTANCE.getRandomVariable();

		/**
		 * The meta object literal for the '<em><b>Prob Function</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RANDOM_VARIABLE__PROB_FUNCTION = eINSTANCE.getRandomVariable_ProbFunction();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityFunctionImpl <em>Probability Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityFunctionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProbabilityFunction()
		 * @generated
		 */
		EClass PROBABILITY_FUNCTION = eINSTANCE.getProbabilityFunction();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.LiteralImpl <em>Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.LiteralImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getLiteral()
		 * @generated
		 */
		EClass LITERAL = eINSTANCE.getLiteral();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BooleanLiteralImpl <em>Boolean Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BooleanLiteralImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBooleanLiteral()
		 * @generated
		 */
		EClass BOOLEAN_LITERAL = eINSTANCE.getBooleanLiteral();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOOLEAN_LITERAL__VALUE = eINSTANCE.getBooleanLiteral_Value();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntLiteralImpl <em>Int Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntLiteralImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getIntLiteral()
		 * @generated
		 */
		EClass INT_LITERAL = eINSTANCE.getIntLiteral();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INT_LITERAL__VALUE = eINSTANCE.getIntLiteral_Value();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleLiteralImpl <em>Double Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleLiteralImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getDoubleLiteral()
		 * @generated
		 */
		EClass DOUBLE_LITERAL = eINSTANCE.getDoubleLiteral();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOUBLE_LITERAL__VALUE = eINSTANCE.getDoubleLiteral_Value();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityMassFunctionImpl <em>Probability Mass Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityMassFunctionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProbabilityMassFunction()
		 * @generated
		 */
		EClass PROBABILITY_MASS_FUNCTION = eINSTANCE.getProbabilityMassFunction();

		/**
		 * The meta object literal for the '<em><b>Samples</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROBABILITY_MASS_FUNCTION__SAMPLES = eINSTANCE.getProbabilityMassFunction_Samples();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.SampleListImpl <em>Sample List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.SampleListImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getSampleList()
		 * @generated
		 */
		EClass SAMPLE_LIST = eINSTANCE.getSampleList();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.SampleImpl <em>Sample</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.SampleImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getSample()
		 * @generated
		 */
		EClass SAMPLE = eINSTANCE.getSample();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleSampleImpl <em>Double Sample</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleSampleImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getDoubleSample()
		 * @generated
		 */
		EClass DOUBLE_SAMPLE = eINSTANCE.getDoubleSample();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOUBLE_SAMPLE__VALUE = eINSTANCE.getDoubleSample_Value();

		/**
		 * The meta object literal for the '<em><b>Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOUBLE_SAMPLE__PROBABILITY = eINSTANCE.getDoubleSample_Probability();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntSampleImpl <em>Int Sample</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntSampleImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getIntSample()
		 * @generated
		 */
		EClass INT_SAMPLE = eINSTANCE.getIntSample();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INT_SAMPLE__VALUE = eINSTANCE.getIntSample_Value();

		/**
		 * The meta object literal for the '<em><b>Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INT_SAMPLE__PROBABILITY = eINSTANCE.getIntSample_Probability();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoolSampleImpl <em>Bool Sample</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoolSampleImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBoolSample()
		 * @generated
		 */
		EClass BOOL_SAMPLE = eINSTANCE.getBoolSample();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOOL_SAMPLE__VALUE = eINSTANCE.getBoolSample_Value();

		/**
		 * The meta object literal for the '<em><b>Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOOL_SAMPLE__PROBABILITY = eINSTANCE.getBoolSample_Probability();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.EnumSampleImpl <em>Enum Sample</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.EnumSampleImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getEnumSample()
		 * @generated
		 */
		EClass ENUM_SAMPLE = eINSTANCE.getEnumSample();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENUM_SAMPLE__VALUE = eINSTANCE.getEnumSample_Value();

		/**
		 * The meta object literal for the '<em><b>Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENUM_SAMPLE__PROBABILITY = eINSTANCE.getEnumSample_Probability();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntSampleListImpl <em>Int Sample List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.IntSampleListImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getIntSampleList()
		 * @generated
		 */
		EClass INT_SAMPLE_LIST = eINSTANCE.getIntSampleList();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INT_SAMPLE_LIST__ITEMS = eINSTANCE.getIntSampleList_Items();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleSampleListImpl <em>Double Sample List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.DoubleSampleListImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getDoubleSampleList()
		 * @generated
		 */
		EClass DOUBLE_SAMPLE_LIST = eINSTANCE.getDoubleSampleList();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOUBLE_SAMPLE_LIST__ITEMS = eINSTANCE.getDoubleSampleList_Items();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoolSampleListImpl <em>Bool Sample List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoolSampleListImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBoolSampleList()
		 * @generated
		 */
		EClass BOOL_SAMPLE_LIST = eINSTANCE.getBoolSampleList();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BOOL_SAMPLE_LIST__ITEMS = eINSTANCE.getBoolSampleList_Items();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.EnumSampleListImpl <em>Enum Sample List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.EnumSampleListImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getEnumSampleList()
		 * @generated
		 */
		EClass ENUM_SAMPLE_LIST = eINSTANCE.getEnumSampleList();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENUM_SAMPLE_LIST__ITEMS = eINSTANCE.getEnumSampleList_Items();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityDensityFunctionImpl <em>Probability Density Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ProbabilityDensityFunctionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProbabilityDensityFunction()
		 * @generated
		 */
		EClass PROBABILITY_DENSITY_FUNCTION = eINSTANCE.getProbabilityDensityFunction();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoxedPDFImpl <em>Boxed PDF</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.BoxedPDFImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBoxedPDF()
		 * @generated
		 */
		EClass BOXED_PDF = eINSTANCE.getBoxedPDF();

		/**
		 * The meta object literal for the '<em><b>Sample</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BOXED_PDF__SAMPLE = eINSTANCE.getBoxedPDF_Sample();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ContinuousSampleImpl <em>Continuous Sample</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ContinuousSampleImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getContinuousSample()
		 * @generated
		 */
		EClass CONTINUOUS_SAMPLE = eINSTANCE.getContinuousSample();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONTINUOUS_SAMPLE__VALUE = eINSTANCE.getContinuousSample_Value();

		/**
		 * The meta object literal for the '<em><b>Probability</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONTINUOUS_SAMPLE__PROBABILITY = eINSTANCE.getContinuousSample_Probability();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ContinuousPDFImpl <em>Continuous PDF</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ContinuousPDFImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getContinuousPDF()
		 * @generated
		 */
		EClass CONTINUOUS_PDF = eINSTANCE.getContinuousPDF();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.NormalDistributionImpl <em>Normal Distribution</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.NormalDistributionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getNormalDistribution()
		 * @generated
		 */
		EClass NORMAL_DISTRIBUTION = eINSTANCE.getNormalDistribution();

		/**
		 * The meta object literal for the '<em><b>Mu</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NORMAL_DISTRIBUTION__MU = eINSTANCE.getNormalDistribution_Mu();

		/**
		 * The meta object literal for the '<em><b>Sigma</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NORMAL_DISTRIBUTION__SIGMA = eINSTANCE.getNormalDistribution_Sigma();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExponentialDistributionImpl <em>Exponential Distribution</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.ExponentialDistributionImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getExponentialDistribution()
		 * @generated
		 */
		EClass EXPONENTIAL_DISTRIBUTION = eINSTANCE.getExponentialDistribution();

		/**
		 * The meta object literal for the '<em><b>Rate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPONENTIAL_DISTRIBUTION__RATE = eINSTANCE.getExponentialDistribution_Rate();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.ProductOperation <em>Product Operation</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.ProductOperation
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getProductOperation()
		 * @generated
		 */
		EEnum PRODUCT_OPERATION = eINSTANCE.getProductOperation();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.TermOperation <em>Term Operation</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.TermOperation
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getTermOperation()
		 * @generated
		 */
		EEnum TERM_OPERATION = eINSTANCE.getTermOperation();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.CompareOperation <em>Compare Operation</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.CompareOperation
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getCompareOperation()
		 * @generated
		 */
		EEnum COMPARE_OPERATION = eINSTANCE.getCompareOperation();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanOperation <em>Boolean Operation</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanOperation
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl#getBooleanOperation()
		 * @generated
		 */
		EEnum BOOLEAN_OPERATION = eINSTANCE.getBooleanOperation();

	}

} //FunctionsPackage
