/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallParameter;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InputParamter;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>External Call Parameter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl#getExternalCall <em>External Call</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl#getParameter <em>Parameter</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ExternalCallParameterImpl extends CallParameterImpl implements ExternalCallParameter {
	/**
	 * The cached value of the '{@link #getExternalCall() <em>External Call</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExternalCall()
	 * @generated
	 * @ordered
	 */
	protected ExternalCall externalCall;

	/**
	 * The cached value of the '{@link #getParameter() <em>Parameter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameter()
	 * @generated
	 * @ordered
	 */
	protected InputParamter parameter;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalCallParameterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ParameterdependenciesPackage.Literals.EXTERNAL_CALL_PARAMETER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExternalCall getExternalCall() {
		if (externalCall != null && externalCall.eIsProxy()) {
			InternalEObject oldExternalCall = (InternalEObject)externalCall;
			externalCall = (ExternalCall)eResolveProxy(oldExternalCall);
			if (externalCall != oldExternalCall) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL, oldExternalCall, externalCall));
			}
		}
		return externalCall;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExternalCall basicGetExternalCall() {
		return externalCall;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setExternalCall(ExternalCall newExternalCall) {
		ExternalCall oldExternalCall = externalCall;
		externalCall = newExternalCall;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL, oldExternalCall, externalCall));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public InputParamter getParameter() {
		if (parameter != null && parameter.eIsProxy()) {
			InternalEObject oldParameter = (InternalEObject)parameter;
			parameter = (InputParamter)eResolveProxy(oldParameter);
			if (parameter != oldParameter) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__PARAMETER, oldParameter, parameter));
			}
		}
		return parameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InputParamter basicGetParameter() {
		return parameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParameter(InputParamter newParameter) {
		InputParamter oldParameter = parameter;
		parameter = newParameter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__PARAMETER, oldParameter, parameter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL:
				if (resolve) return getExternalCall();
				return basicGetExternalCall();
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__PARAMETER:
				if (resolve) return getParameter();
				return basicGetParameter();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL:
				setExternalCall((ExternalCall)newValue);
				return;
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__PARAMETER:
				setParameter((InputParamter)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL:
				setExternalCall((ExternalCall)null);
				return;
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__PARAMETER:
				setParameter((InputParamter)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__EXTERNAL_CALL:
				return externalCall != null;
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER__PARAMETER:
				return parameter != null;
		}
		return super.eIsSet(featureID);
	}

} //ExternalCallParameterImpl
