/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Relationship</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getSurroundingEntity <em>Surrounding Entity</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getExplicitDescription <em>Explicit Description</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getCharacterization <em>Characterization</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class RelationshipImpl extends EObjectImpl implements Relationship {
	/**
	 * The cached value of the '{@link #getExplicitDescription() <em>Explicit Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExplicitDescription()
	 * @generated
	 * @ordered
	 */
	protected ExplicitDescription explicitDescription;

	/**
	 * The default value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected static final RelationshipCharacterizationType CHARACTERIZATION_EDEFAULT = RelationshipCharacterizationType.EMPIRICAL;

	/**
	 * The cached value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected RelationshipCharacterizationType characterization = CHARACTERIZATION_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RelationshipImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ParameterdependenciesPackage.Literals.RELATIONSHIP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public InterfaceProvidingRequiringEntity getSurroundingEntity() {
		if (eContainerFeatureID() != ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY) return null;
		return (InterfaceProvidingRequiringEntity)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSurroundingEntity(InterfaceProvidingRequiringEntity newSurroundingEntity, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newSurroundingEntity, ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSurroundingEntity(InterfaceProvidingRequiringEntity newSurroundingEntity) {
		if (newSurroundingEntity != eInternalContainer() || (eContainerFeatureID() != ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY && newSurroundingEntity != null)) {
			if (EcoreUtil.isAncestor(this, newSurroundingEntity))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newSurroundingEntity != null)
				msgs = ((InternalEObject)newSurroundingEntity).eInverseAdd(this, RepositoryPackage.INTERFACE_PROVIDING_REQUIRING_ENTITY__RELATIONSHIPS, InterfaceProvidingRequiringEntity.class, msgs);
			msgs = basicSetSurroundingEntity(newSurroundingEntity, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY, newSurroundingEntity, newSurroundingEntity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ExplicitDescription getExplicitDescription() {
		return explicitDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExplicitDescription(ExplicitDescription newExplicitDescription, NotificationChain msgs) {
		ExplicitDescription oldExplicitDescription = explicitDescription;
		explicitDescription = newExplicitDescription;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION, oldExplicitDescription, newExplicitDescription);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setExplicitDescription(ExplicitDescription newExplicitDescription) {
		if (newExplicitDescription != explicitDescription) {
			NotificationChain msgs = null;
			if (explicitDescription != null)
				msgs = ((InternalEObject)explicitDescription).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION, null, msgs);
			if (newExplicitDescription != null)
				msgs = ((InternalEObject)newExplicitDescription).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION, null, msgs);
			msgs = basicSetExplicitDescription(newExplicitDescription, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION, newExplicitDescription, newExplicitDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public RelationshipCharacterizationType getCharacterization() {
		return characterization;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCharacterization(RelationshipCharacterizationType newCharacterization) {
		RelationshipCharacterizationType oldCharacterization = characterization;
		characterization = newCharacterization == null ? CHARACTERIZATION_EDEFAULT : newCharacterization;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION, oldCharacterization, characterization));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetSurroundingEntity((InterfaceProvidingRequiringEntity)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				return basicSetSurroundingEntity(null, msgs);
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				return basicSetExplicitDescription(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				return eInternalContainer().eInverseRemove(this, RepositoryPackage.INTERFACE_PROVIDING_REQUIRING_ENTITY__RELATIONSHIPS, InterfaceProvidingRequiringEntity.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				return getSurroundingEntity();
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				return getExplicitDescription();
			case ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION:
				return getCharacterization();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				setSurroundingEntity((InterfaceProvidingRequiringEntity)newValue);
				return;
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				setExplicitDescription((ExplicitDescription)newValue);
				return;
			case ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION:
				setCharacterization((RelationshipCharacterizationType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				setSurroundingEntity((InterfaceProvidingRequiringEntity)null);
				return;
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				setExplicitDescription((ExplicitDescription)null);
				return;
			case ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION:
				setCharacterization(CHARACTERIZATION_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				return getSurroundingEntity() != null;
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				return explicitDescription != null;
			case ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION:
				return characterization != CHARACTERIZATION_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (characterization: ");
		result.append(characterization);
		result.append(')');
		return result.toString();
	}

} //RelationshipImpl
