/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServiceBehaviorAbstraction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Service Behavior Abstraction</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ServiceBehaviorAbstractionImpl#getDescribedSignature <em>Described Signature</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ServiceBehaviorAbstractionImpl#getInfluencingParameter <em>Influencing Parameter</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ServiceBehaviorAbstractionImpl#getInfluencedVariableReference <em>Influenced Variable Reference</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ServiceBehaviorAbstractionImpl#getInterfaceProvidingRole <em>Interface Providing Role</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ServiceBehaviorAbstractionImpl extends EObjectImpl implements ServiceBehaviorAbstraction {
	/**
	 * The cached value of the '{@link #getDescribedSignature() <em>Described Signature</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescribedSignature()
	 * @generated
	 * @ordered
	 */
	protected Signature describedSignature;

	/**
	 * The cached value of the '{@link #getInfluencingParameter() <em>Influencing Parameter</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInfluencingParameter()
	 * @generated
	 * @ordered
	 */
	protected EList<InfluencingParameter> influencingParameter;

	/**
	 * The cached value of the '{@link #getInfluencedVariableReference() <em>Influenced Variable Reference</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInfluencedVariableReference()
	 * @generated
	 * @ordered
	 */
	protected EList<InfluencedVariableReference> influencedVariableReference;

	/**
	 * The cached value of the '{@link #getInterfaceProvidingRole() <em>Interface Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceProvidingRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceProvidingRole interfaceProvidingRole;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ServiceBehaviorAbstractionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.SERVICE_BEHAVIOR_ABSTRACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Signature getDescribedSignature() {
		if (describedSignature != null && describedSignature.eIsProxy()) {
			InternalEObject oldDescribedSignature = (InternalEObject)describedSignature;
			describedSignature = (Signature)eResolveProxy(oldDescribedSignature);
			if (describedSignature != oldDescribedSignature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE, oldDescribedSignature, describedSignature));
			}
		}
		return describedSignature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signature basicGetDescribedSignature() {
		return describedSignature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setDescribedSignature(Signature newDescribedSignature) {
		Signature oldDescribedSignature = describedSignature;
		describedSignature = newDescribedSignature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE, oldDescribedSignature, describedSignature));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<InfluencingParameter> getInfluencingParameter() {
		if (influencingParameter == null) {
			influencingParameter = new EObjectContainmentWithInverseEList<InfluencingParameter>(InfluencingParameter.class, this, ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER, ParameterdependenciesPackage.INFLUENCING_PARAMETER__BEHAVIOR);
		}
		return influencingParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<InfluencedVariableReference> getInfluencedVariableReference() {
		if (influencedVariableReference == null) {
			influencedVariableReference = new EObjectContainmentEList<InfluencedVariableReference>(InfluencedVariableReference.class, this, ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCED_VARIABLE_REFERENCE);
		}
		return influencedVariableReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public InterfaceProvidingRole getInterfaceProvidingRole() {
		if (interfaceProvidingRole != null && interfaceProvidingRole.eIsProxy()) {
			InternalEObject oldInterfaceProvidingRole = (InternalEObject)interfaceProvidingRole;
			interfaceProvidingRole = (InterfaceProvidingRole)eResolveProxy(oldInterfaceProvidingRole);
			if (interfaceProvidingRole != oldInterfaceProvidingRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INTERFACE_PROVIDING_ROLE, oldInterfaceProvidingRole, interfaceProvidingRole));
			}
		}
		return interfaceProvidingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole basicGetInterfaceProvidingRole() {
		return interfaceProvidingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInterfaceProvidingRole(InterfaceProvidingRole newInterfaceProvidingRole) {
		InterfaceProvidingRole oldInterfaceProvidingRole = interfaceProvidingRole;
		interfaceProvidingRole = newInterfaceProvidingRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INTERFACE_PROVIDING_ROLE, oldInterfaceProvidingRole, interfaceProvidingRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInfluencingParameter()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER:
				return ((InternalEList<?>)getInfluencingParameter()).basicRemove(otherEnd, msgs);
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCED_VARIABLE_REFERENCE:
				return ((InternalEList<?>)getInfluencedVariableReference()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE:
				if (resolve) return getDescribedSignature();
				return basicGetDescribedSignature();
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER:
				return getInfluencingParameter();
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCED_VARIABLE_REFERENCE:
				return getInfluencedVariableReference();
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INTERFACE_PROVIDING_ROLE:
				if (resolve) return getInterfaceProvidingRole();
				return basicGetInterfaceProvidingRole();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE:
				setDescribedSignature((Signature)newValue);
				return;
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER:
				getInfluencingParameter().clear();
				getInfluencingParameter().addAll((Collection<? extends InfluencingParameter>)newValue);
				return;
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCED_VARIABLE_REFERENCE:
				getInfluencedVariableReference().clear();
				getInfluencedVariableReference().addAll((Collection<? extends InfluencedVariableReference>)newValue);
				return;
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INTERFACE_PROVIDING_ROLE:
				setInterfaceProvidingRole((InterfaceProvidingRole)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE:
				setDescribedSignature((Signature)null);
				return;
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER:
				getInfluencingParameter().clear();
				return;
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCED_VARIABLE_REFERENCE:
				getInfluencedVariableReference().clear();
				return;
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INTERFACE_PROVIDING_ROLE:
				setInterfaceProvidingRole((InterfaceProvidingRole)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE:
				return describedSignature != null;
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER:
				return influencingParameter != null && !influencingParameter.isEmpty();
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCED_VARIABLE_REFERENCE:
				return influencedVariableReference != null && !influencedVariableReference.isEmpty();
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION__INTERFACE_PROVIDING_ROLE:
				return interfaceProvidingRole != null;
		}
		return super.eIsSet(featureID);
	}

} //ServiceBehaviorAbstractionImpl
