/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape;

import edu.kit.ipd.descartes.core.CorePackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapeFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface ResourcelandscapePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "resourcelandscape";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes-research.net/metamodel/resourcelandscape/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "resourcelandscape";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ResourcelandscapePackage eINSTANCE = edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.ContainerImpl <em>Container</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ContainerImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getContainer()
	 * @generated
	 */
	int CONTAINER = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER__CONTAINS = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Config Spec</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER__CONFIG_SPEC = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Template</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER__TEMPLATE = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Container</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.ComputingInfrastructureImpl <em>Computing Infrastructure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ComputingInfrastructureImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getComputingInfrastructure()
	 * @generated
	 */
	int COMPUTING_INFRASTRUCTURE = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTING_INFRASTRUCTURE__ID = CONTAINER__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTING_INFRASTRUCTURE__NAME = CONTAINER__NAME;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTING_INFRASTRUCTURE__CONTAINS = CONTAINER__CONTAINS;

	/**
	 * The feature id for the '<em><b>Config Spec</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTING_INFRASTRUCTURE__CONFIG_SPEC = CONTAINER__CONFIG_SPEC;

	/**
	 * The feature id for the '<em><b>Template</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTING_INFRASTRUCTURE__TEMPLATE = CONTAINER__TEMPLATE;

	/**
	 * The feature id for the '<em><b>Part Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTING_INFRASTRUCTURE__PART_OF = CONTAINER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Computing Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPUTING_INFRASTRUCTURE_FEATURE_COUNT = CONTAINER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.NetworkingInfrastructureImpl <em>Networking Infrastructure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.NetworkingInfrastructureImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getNetworkingInfrastructure()
	 * @generated
	 */
	int NETWORKING_INFRASTRUCTURE = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORKING_INFRASTRUCTURE__ID = CONTAINER__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORKING_INFRASTRUCTURE__NAME = CONTAINER__NAME;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORKING_INFRASTRUCTURE__CONTAINS = CONTAINER__CONTAINS;

	/**
	 * The feature id for the '<em><b>Config Spec</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORKING_INFRASTRUCTURE__CONFIG_SPEC = CONTAINER__CONFIG_SPEC;

	/**
	 * The feature id for the '<em><b>Template</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORKING_INFRASTRUCTURE__TEMPLATE = CONTAINER__TEMPLATE;

	/**
	 * The feature id for the '<em><b>Part Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORKING_INFRASTRUCTURE__PART_OF = CONTAINER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Networking Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORKING_INFRASTRUCTURE_FEATURE_COUNT = CONTAINER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.StorageInfrastructureImpl <em>Storage Infrastructure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.StorageInfrastructureImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getStorageInfrastructure()
	 * @generated
	 */
	int STORAGE_INFRASTRUCTURE = 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORAGE_INFRASTRUCTURE__ID = CONTAINER__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORAGE_INFRASTRUCTURE__NAME = CONTAINER__NAME;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORAGE_INFRASTRUCTURE__CONTAINS = CONTAINER__CONTAINS;

	/**
	 * The feature id for the '<em><b>Config Spec</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORAGE_INFRASTRUCTURE__CONFIG_SPEC = CONTAINER__CONFIG_SPEC;

	/**
	 * The feature id for the '<em><b>Template</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORAGE_INFRASTRUCTURE__TEMPLATE = CONTAINER__TEMPLATE;

	/**
	 * The feature id for the '<em><b>Part Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORAGE_INFRASTRUCTURE__PART_OF = CONTAINER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Storage Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STORAGE_INFRASTRUCTURE_FEATURE_COUNT = CONTAINER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.RuntimeEnvironmentImpl <em>Runtime Environment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.RuntimeEnvironmentImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getRuntimeEnvironment()
	 * @generated
	 */
	int RUNTIME_ENVIRONMENT = 4;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNTIME_ENVIRONMENT__ID = CONTAINER__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNTIME_ENVIRONMENT__NAME = CONTAINER__NAME;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNTIME_ENVIRONMENT__CONTAINS = CONTAINER__CONTAINS;

	/**
	 * The feature id for the '<em><b>Config Spec</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNTIME_ENVIRONMENT__CONFIG_SPEC = CONTAINER__CONFIG_SPEC;

	/**
	 * The feature id for the '<em><b>Template</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNTIME_ENVIRONMENT__TEMPLATE = CONTAINER__TEMPLATE;

	/**
	 * The feature id for the '<em><b>Contained In</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNTIME_ENVIRONMENT__CONTAINED_IN = CONTAINER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Of Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNTIME_ENVIRONMENT__OF_CLASS = CONTAINER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Runtime Environment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RUNTIME_ENVIRONMENT_FEATURE_COUNT = CONTAINER_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.DataCenterImpl <em>Data Center</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.DataCenterImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getDataCenter()
	 * @generated
	 */
	int DATA_CENTER = 5;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CENTER__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CENTER__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Belongs To</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CENTER__BELONGS_TO = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CENTER__CONTAINS = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Data Center</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_CENTER_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.DistributedDataCenterImpl <em>Distributed Data Center</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.DistributedDataCenterImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getDistributedDataCenter()
	 * @generated
	 */
	int DISTRIBUTED_DATA_CENTER = 6;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTRIBUTED_DATA_CENTER__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTRIBUTED_DATA_CENTER__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Consists Of</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTRIBUTED_DATA_CENTER__CONSISTS_OF = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Distributed Data Center</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISTRIBUTED_DATA_CENTER_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.HardwareInfrastructureImpl <em>Hardware Infrastructure</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.HardwareInfrastructureImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getHardwareInfrastructure()
	 * @generated
	 */
    int HARDWARE_INFRASTRUCTURE = 8;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HARDWARE_INFRASTRUCTURE__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HARDWARE_INFRASTRUCTURE__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Part Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HARDWARE_INFRASTRUCTURE__PART_OF = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Hardware Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HARDWARE_INFRASTRUCTURE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.CompositeHardwareInfrastructureImpl <em>Composite Hardware Infrastructure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.CompositeHardwareInfrastructureImpl
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getCompositeHardwareInfrastructure()
	 * @generated
	 */
	int COMPOSITE_HARDWARE_INFRASTRUCTURE = 7;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMPOSITE_HARDWARE_INFRASTRUCTURE__ID = HARDWARE_INFRASTRUCTURE__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COMPOSITE_HARDWARE_INFRASTRUCTURE__NAME = HARDWARE_INFRASTRUCTURE__NAME;

    /**
	 * The feature id for the '<em><b>Part Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_HARDWARE_INFRASTRUCTURE__PART_OF = HARDWARE_INFRASTRUCTURE__PART_OF;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_HARDWARE_INFRASTRUCTURE__CONTAINS = HARDWARE_INFRASTRUCTURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Composite Hardware Infrastructure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_HARDWARE_INFRASTRUCTURE_FEATURE_COUNT = HARDWARE_INFRASTRUCTURE_FEATURE_COUNT + 1;


	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.ComputingInfrastructure <em>Computing Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Computing Infrastructure</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.ComputingInfrastructure
	 * @generated
	 */
	EClass getComputingInfrastructure();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.NetworkingInfrastructure <em>Networking Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Networking Infrastructure</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.NetworkingInfrastructure
	 * @generated
	 */
	EClass getNetworkingInfrastructure();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.StorageInfrastructure <em>Storage Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Storage Infrastructure</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.StorageInfrastructure
	 * @generated
	 */
	EClass getStorageInfrastructure();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.Container <em>Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Container</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.Container
	 * @generated
	 */
	EClass getContainer();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.resourcelandscape.Container#getContains <em>Contains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.Container#getContains()
	 * @see #getContainer()
	 * @generated
	 */
	EReference getContainer_Contains();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.resourcelandscape.Container#getConfigSpec <em>Config Spec</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Config Spec</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.Container#getConfigSpec()
	 * @see #getContainer()
	 * @generated
	 */
	EReference getContainer_ConfigSpec();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.resourcelandscape.Container#getTemplate <em>Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Template</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.Container#getTemplate()
	 * @see #getContainer()
	 * @generated
	 */
	EReference getContainer_Template();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment <em>Runtime Environment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Runtime Environment</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment
	 * @generated
	 */
	EClass getRuntimeEnvironment();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment#getContainedIn <em>Contained In</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Contained In</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment#getContainedIn()
	 * @see #getRuntimeEnvironment()
	 * @generated
	 */
	EReference getRuntimeEnvironment_ContainedIn();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment#getOfClass <em>Of Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Of Class</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment#getOfClass()
	 * @see #getRuntimeEnvironment()
	 * @generated
	 */
	EAttribute getRuntimeEnvironment_OfClass();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter <em>Data Center</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Center</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter
	 * @generated
	 */
	EClass getDataCenter();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter#getBelongsTo <em>Belongs To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Belongs To</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter#getBelongsTo()
	 * @see #getDataCenter()
	 * @generated
	 */
	EReference getDataCenter_BelongsTo();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter#getContains <em>Contains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter#getContains()
	 * @see #getDataCenter()
	 * @generated
	 */
	EReference getDataCenter_Contains();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter <em>Distributed Data Center</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Distributed Data Center</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter
	 * @generated
	 */
	EClass getDistributedDataCenter();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter#getConsistsOf <em>Consists Of</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Consists Of</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter#getConsistsOf()
	 * @see #getDistributedDataCenter()
	 * @generated
	 */
	EReference getDistributedDataCenter_ConsistsOf();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.CompositeHardwareInfrastructure <em>Composite Hardware Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composite Hardware Infrastructure</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.CompositeHardwareInfrastructure
	 * @generated
	 */
	EClass getCompositeHardwareInfrastructure();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.resourcelandscape.CompositeHardwareInfrastructure#getContains <em>Contains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.CompositeHardwareInfrastructure#getContains()
	 * @see #getCompositeHardwareInfrastructure()
	 * @generated
	 */
	EReference getCompositeHardwareInfrastructure_Contains();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.resourcelandscape.HardwareInfrastructure <em>Hardware Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hardware Infrastructure</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.HardwareInfrastructure
	 * @generated
	 */
    EClass getHardwareInfrastructure();

    /**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.resourcelandscape.HardwareInfrastructure#getPartOf <em>Part Of</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Part Of</em>'.
	 * @see edu.kit.ipd.descartes.mm.resourcelandscape.HardwareInfrastructure#getPartOf()
	 * @see #getHardwareInfrastructure()
	 * @generated
	 */
    EReference getHardwareInfrastructure_PartOf();

    /**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ResourcelandscapeFactory getResourcelandscapeFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.ComputingInfrastructureImpl <em>Computing Infrastructure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ComputingInfrastructureImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getComputingInfrastructure()
		 * @generated
		 */
		EClass COMPUTING_INFRASTRUCTURE = eINSTANCE.getComputingInfrastructure();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.NetworkingInfrastructureImpl <em>Networking Infrastructure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.NetworkingInfrastructureImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getNetworkingInfrastructure()
		 * @generated
		 */
		EClass NETWORKING_INFRASTRUCTURE = eINSTANCE.getNetworkingInfrastructure();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.StorageInfrastructureImpl <em>Storage Infrastructure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.StorageInfrastructureImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getStorageInfrastructure()
		 * @generated
		 */
		EClass STORAGE_INFRASTRUCTURE = eINSTANCE.getStorageInfrastructure();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.ContainerImpl <em>Container</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ContainerImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getContainer()
		 * @generated
		 */
		EClass CONTAINER = eINSTANCE.getContainer();

		/**
		 * The meta object literal for the '<em><b>Contains</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTAINER__CONTAINS = eINSTANCE.getContainer_Contains();

		/**
		 * The meta object literal for the '<em><b>Config Spec</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTAINER__CONFIG_SPEC = eINSTANCE.getContainer_ConfigSpec();

		/**
		 * The meta object literal for the '<em><b>Template</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTAINER__TEMPLATE = eINSTANCE.getContainer_Template();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.RuntimeEnvironmentImpl <em>Runtime Environment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.RuntimeEnvironmentImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getRuntimeEnvironment()
		 * @generated
		 */
		EClass RUNTIME_ENVIRONMENT = eINSTANCE.getRuntimeEnvironment();

		/**
		 * The meta object literal for the '<em><b>Contained In</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RUNTIME_ENVIRONMENT__CONTAINED_IN = eINSTANCE.getRuntimeEnvironment_ContainedIn();

		/**
		 * The meta object literal for the '<em><b>Of Class</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RUNTIME_ENVIRONMENT__OF_CLASS = eINSTANCE.getRuntimeEnvironment_OfClass();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.DataCenterImpl <em>Data Center</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.DataCenterImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getDataCenter()
		 * @generated
		 */
		EClass DATA_CENTER = eINSTANCE.getDataCenter();

		/**
		 * The meta object literal for the '<em><b>Belongs To</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_CENTER__BELONGS_TO = eINSTANCE.getDataCenter_BelongsTo();

		/**
		 * The meta object literal for the '<em><b>Contains</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_CENTER__CONTAINS = eINSTANCE.getDataCenter_Contains();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.DistributedDataCenterImpl <em>Distributed Data Center</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.DistributedDataCenterImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getDistributedDataCenter()
		 * @generated
		 */
		EClass DISTRIBUTED_DATA_CENTER = eINSTANCE.getDistributedDataCenter();

		/**
		 * The meta object literal for the '<em><b>Consists Of</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DISTRIBUTED_DATA_CENTER__CONSISTS_OF = eINSTANCE.getDistributedDataCenter_ConsistsOf();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.CompositeHardwareInfrastructureImpl <em>Composite Hardware Infrastructure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.CompositeHardwareInfrastructureImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getCompositeHardwareInfrastructure()
		 * @generated
		 */
		EClass COMPOSITE_HARDWARE_INFRASTRUCTURE = eINSTANCE.getCompositeHardwareInfrastructure();

		/**
		 * The meta object literal for the '<em><b>Contains</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSITE_HARDWARE_INFRASTRUCTURE__CONTAINS = eINSTANCE.getCompositeHardwareInfrastructure_Contains();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.HardwareInfrastructureImpl <em>Hardware Infrastructure</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.HardwareInfrastructureImpl
		 * @see edu.kit.ipd.descartes.mm.resourcelandscape.impl.ResourcelandscapePackageImpl#getHardwareInfrastructure()
		 * @generated
		 */
        EClass HARDWARE_INFRASTRUCTURE = eINSTANCE.getHardwareInfrastructure();

        /**
		 * The meta object literal for the '<em><b>Part Of</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference HARDWARE_INFRASTRUCTURE__PART_OF = eINSTANCE.getHardwareInfrastructure_PartOf();

	}

} //ResourcelandscapePackage
