/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape.util;

import edu.kit.ipd.descartes.identifier.util.IdentifierValidator;

import edu.kit.ipd.descartes.mm.resourcelandscape.*;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage
 * @generated
 */
public class ResourcelandscapeValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final ResourcelandscapeValidator INSTANCE = new ResourcelandscapeValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "edu.kit.ipd.descartes.mm.resourcelandscape";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourcelandscapeValidator() {
		super();
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return ResourcelandscapePackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case ResourcelandscapePackage.COMPUTING_INFRASTRUCTURE:
				return validateComputingInfrastructure((ComputingInfrastructure)value, diagnostics, context);
			case ResourcelandscapePackage.NETWORKING_INFRASTRUCTURE:
				return validateNetworkingInfrastructure((NetworkingInfrastructure)value, diagnostics, context);
			case ResourcelandscapePackage.STORAGE_INFRASTRUCTURE:
				return validateStorageInfrastructure((StorageInfrastructure)value, diagnostics, context);
			case ResourcelandscapePackage.CONTAINER:
				return validateContainer((Container)value, diagnostics, context);
			case ResourcelandscapePackage.RUNTIME_ENVIRONMENT:
				return validateRuntimeEnvironment((RuntimeEnvironment)value, diagnostics, context);
			case ResourcelandscapePackage.DATA_CENTER:
				return validateDataCenter((DataCenter)value, diagnostics, context);
			case ResourcelandscapePackage.DISTRIBUTED_DATA_CENTER:
				return validateDistributedDataCenter((DistributedDataCenter)value, diagnostics, context);
			case ResourcelandscapePackage.COMPOSITE_HARDWARE_INFRASTRUCTURE:
				return validateCompositeHardwareInfrastructure((CompositeHardwareInfrastructure)value, diagnostics, context);
			case ResourcelandscapePackage.HARDWARE_INFRASTRUCTURE:
				return validateHardwareInfrastructure((HardwareInfrastructure)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComputingInfrastructure(ComputingInfrastructure computingInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(computingInfrastructure, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateNetworkingInfrastructure(NetworkingInfrastructure networkingInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(networkingInfrastructure, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateStorageInfrastructure(StorageInfrastructure storageInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(storageInfrastructure, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateContainer(Container container, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(container, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateRuntimeEnvironment(RuntimeEnvironment runtimeEnvironment, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(runtimeEnvironment, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(runtimeEnvironment, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(runtimeEnvironment, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(runtimeEnvironment, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(runtimeEnvironment, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(runtimeEnvironment, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(runtimeEnvironment, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(runtimeEnvironment, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(runtimeEnvironment, diagnostics, context);
		if (result || diagnostics != null) result &= validateRuntimeEnvironment_runtimeEnvironmentLevelCompliance(runtimeEnvironment, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the runtimeEnvironmentLevelCompliance constraint of '<em>Runtime Environment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String RUNTIME_ENVIRONMENT__RUNTIME_ENVIRONMENT_LEVEL_COMPLIANCE__EEXPRESSION = "self.containedIn.contains->forAll(r : RuntimeEnvironment | r.ofClass = self.ofClass)";

	/**
	 * Validates the runtimeEnvironmentLevelCompliance constraint of '<em>Runtime Environment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateRuntimeEnvironment_runtimeEnvironmentLevelCompliance(RuntimeEnvironment runtimeEnvironment, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ResourcelandscapePackage.Literals.RUNTIME_ENVIRONMENT,
				 runtimeEnvironment,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "runtimeEnvironmentLevelCompliance",
				 RUNTIME_ENVIRONMENT__RUNTIME_ENVIRONMENT_LEVEL_COMPLIANCE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDataCenter(DataCenter dataCenter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(dataCenter, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDistributedDataCenter(DistributedDataCenter distributedDataCenter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(distributedDataCenter, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCompositeHardwareInfrastructure(CompositeHardwareInfrastructure compositeHardwareInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(compositeHardwareInfrastructure, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public boolean validateHardwareInfrastructure(HardwareInfrastructure hardwareInfrastructure, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(hardwareInfrastructure, diagnostics, context);
	}

    /**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //ResourcelandscapeValidator
