/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile;

import edu.kit.ipd.descartes.core.CorePackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfileFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import core_0='../../edu.kit.ipd.descartes.core/model/core.ecore#/' ecore_0='http://www.eclipse.org/emf/2002/Ecore' functions_0='../../edu.kit.ipd.descartes.mm.applicationlevel/model/functions.ecore#/' parameterdependency_0='../../edu.kit.ipd.descartes.mm.applicationlevel/model/parameterdependency.ecore#/' repository_0='../../edu.kit.ipd.descartes.mm.applicationlevel/model/repository.ecore#/' system_0='../../edu.kit.ipd.descartes.mm.applicationlevel/model/system.ecore#/'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface UsageProfilePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "usageprofile";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes-research.net/metamodel/usageprofile/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "usageprofile";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	UsageProfilePackage eINSTANCE = edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfileImpl <em>Usage Profile</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfileImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getUsageProfile()
	 * @generated
	 */
	int USAGE_PROFILE = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_PROFILE__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_PROFILE__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Imports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_PROFILE__IMPORTS = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>System</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_PROFILE__SYSTEM = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Usage Scenarios</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_PROFILE__USAGE_SCENARIOS = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Usage Profile</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_PROFILE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.UsageScenarioImpl <em>Usage Scenario</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageScenarioImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getUsageScenario()
	 * @generated
	 */
	int USAGE_SCENARIO = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Usage Model</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__USAGE_MODEL = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Scenario Behavior</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__SCENARIO_BEHAVIOR = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Workload Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO__WORKLOAD_TYPE = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Usage Scenario</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USAGE_SCENARIO_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.ScenarioBehaviorImpl <em>Scenario Behavior</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.ScenarioBehaviorImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getScenarioBehavior()
	 * @generated
	 */
	int SCENARIO_BEHAVIOR = 2;

	/**
	 * The feature id for the '<em><b>Actions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCENARIO_BEHAVIOR__ACTIONS = 0;

	/**
	 * The number of structural features of the '<em>Scenario Behavior</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCENARIO_BEHAVIOR_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.WorkloadTypeImpl <em>Workload Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.WorkloadTypeImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getWorkloadType()
	 * @generated
	 */
	int WORKLOAD_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Usage Scenario</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_TYPE__USAGE_SCENARIO = 0;

	/**
	 * The number of structural features of the '<em>Workload Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WORKLOAD_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.ImportImpl <em>Import</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.ImportImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getImport()
	 * @generated
	 */
	int IMPORT = 4;

	/**
	 * The feature id for the '<em><b>Import URI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPORT__IMPORT_URI = 0;

	/**
	 * The feature id for the '<em><b>Usageprofile</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPORT__USAGEPROFILE = 1;

	/**
	 * The number of structural features of the '<em>Import</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPORT_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.OpenWorkloadTypeImpl <em>Open Workload Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.OpenWorkloadTypeImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getOpenWorkloadType()
	 * @generated
	 */
	int OPEN_WORKLOAD_TYPE = 5;

	/**
	 * The feature id for the '<em><b>Usage Scenario</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_WORKLOAD_TYPE__USAGE_SCENARIO = WORKLOAD_TYPE__USAGE_SCENARIO;

	/**
	 * The feature id for the '<em><b>Inter Arrival Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME = WORKLOAD_TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Open Workload Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPEN_WORKLOAD_TYPE_FEATURE_COUNT = WORKLOAD_TYPE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.ClosedWorkloadTypeImpl <em>Closed Workload Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.ClosedWorkloadTypeImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getClosedWorkloadType()
	 * @generated
	 */
	int CLOSED_WORKLOAD_TYPE = 6;

	/**
	 * The feature id for the '<em><b>Usage Scenario</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOSED_WORKLOAD_TYPE__USAGE_SCENARIO = WORKLOAD_TYPE__USAGE_SCENARIO;

	/**
	 * The feature id for the '<em><b>Population</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOSED_WORKLOAD_TYPE__POPULATION = WORKLOAD_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Think Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOSED_WORKLOAD_TYPE__THINK_TIME = WORKLOAD_TYPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Closed Workload Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOSED_WORKLOAD_TYPE_FEATURE_COUNT = WORKLOAD_TYPE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.AbstractUserActionImpl <em>Abstract User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.AbstractUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getAbstractUserAction()
	 * @generated
	 */
	int ABSTRACT_USER_ACTION = 7;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = 0;

	/**
	 * The number of structural features of the '<em>Abstract User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_USER_ACTION_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.LoopUserActionImpl <em>Loop User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.LoopUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getLoopUserAction()
	 * @generated
	 */
	int LOOP_USER_ACTION = 8;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Loop Body Scenario Behavior</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Loop Iteration Count</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_USER_ACTION__LOOP_ITERATION_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Loop User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOOP_USER_ACTION_FEATURE_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.DelayUserActionImpl <em>Delay User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.DelayUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getDelayUserAction()
	 * @generated
	 */
	int DELAY_USER_ACTION = 9;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY_USER_ACTION__DELAY = ABSTRACT_USER_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Delay User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY_USER_ACTION_FEATURE_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.BranchUserActionImpl <em>Branch User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.BranchUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getBranchUserAction()
	 * @generated
	 */
	int BRANCH_USER_ACTION = 10;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Branches</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_USER_ACTION__BRANCHES = ABSTRACT_USER_ACTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Branching Probabilities</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_USER_ACTION__BRANCHING_PROBABILITIES = ABSTRACT_USER_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Branch User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BRANCH_USER_ACTION_FEATURE_COUNT = ABSTRACT_USER_ACTION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl <em>System Call User Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getSystemCallUserAction()
	 * @generated
	 */
	int SYSTEM_CALL_USER_ACTION = 11;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CALL_USER_ACTION__ID = CorePackage.ENTITY__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CALL_USER_ACTION__NAME = CorePackage.ENTITY__NAME;

	/**
	 * The feature id for the '<em><b>Parent Scenario Behavior</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = CorePackage.ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE = CorePackage.ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CALL_USER_ACTION__SIGNATURE = CorePackage.ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Input Parameter Settings</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS = CorePackage.ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>System Call User Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_CALL_USER_ACTION_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.CallParameterSettingImpl <em>Call Parameter Setting</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.CallParameterSettingImpl
	 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getCallParameterSetting()
	 * @generated
	 */
	int CALL_PARAMETER_SETTING = 12;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_SETTING__NAME = 0;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_SETTING__CHARACTERIZATION = 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_SETTING__VALUE = 2;

	/**
	 * The number of structural features of the '<em>Call Parameter Setting</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_SETTING_FEATURE_COUNT = 3;


	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageProfile <em>Usage Profile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Usage Profile</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfile
	 * @generated
	 */
	EClass getUsageProfile();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageProfile#getImports <em>Imports</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Imports</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfile#getImports()
	 * @see #getUsageProfile()
	 * @generated
	 */
	EReference getUsageProfile_Imports();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageProfile#getSystem <em>System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>System</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfile#getSystem()
	 * @see #getUsageProfile()
	 * @generated
	 */
	EReference getUsageProfile_System();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageProfile#getUsageScenarios <em>Usage Scenarios</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Usage Scenarios</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfile#getUsageScenarios()
	 * @see #getUsageProfile()
	 * @generated
	 */
	EReference getUsageProfile_UsageScenarios();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario <em>Usage Scenario</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Usage Scenario</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageScenario
	 * @generated
	 */
	EClass getUsageScenario();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getUsageModel <em>Usage Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Usage Model</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getUsageModel()
	 * @see #getUsageScenario()
	 * @generated
	 */
	EReference getUsageScenario_UsageModel();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getScenarioBehavior <em>Scenario Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scenario Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getScenarioBehavior()
	 * @see #getUsageScenario()
	 * @generated
	 */
	EReference getUsageScenario_ScenarioBehavior();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getWorkloadType <em>Workload Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Workload Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getWorkloadType()
	 * @see #getUsageScenario()
	 * @generated
	 */
	EReference getUsageScenario_WorkloadType();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior <em>Scenario Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scenario Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior
	 * @generated
	 */
	EClass getScenarioBehavior();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior#getActions <em>Actions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Actions</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior#getActions()
	 * @see #getScenarioBehavior()
	 * @generated
	 */
	EReference getScenarioBehavior_Actions();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.WorkloadType <em>Workload Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Workload Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.WorkloadType
	 * @generated
	 */
	EClass getWorkloadType();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.usageprofile.WorkloadType#getUsageScenario <em>Usage Scenario</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Usage Scenario</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.WorkloadType#getUsageScenario()
	 * @see #getWorkloadType()
	 * @generated
	 */
	EReference getWorkloadType_UsageScenario();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.Import <em>Import</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Import</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.Import
	 * @generated
	 */
	EClass getImport();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.usageprofile.Import#getImportURI <em>Import URI</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Import URI</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.Import#getImportURI()
	 * @see #getImport()
	 * @generated
	 */
	EAttribute getImport_ImportURI();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.usageprofile.Import#getUsageprofile <em>Usageprofile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Usageprofile</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.Import#getUsageprofile()
	 * @see #getImport()
	 * @generated
	 */
	EReference getImport_Usageprofile();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.OpenWorkloadType <em>Open Workload Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Open Workload Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.OpenWorkloadType
	 * @generated
	 */
	EClass getOpenWorkloadType();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.OpenWorkloadType#getInterArrivalTime <em>Inter Arrival Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Inter Arrival Time</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.OpenWorkloadType#getInterArrivalTime()
	 * @see #getOpenWorkloadType()
	 * @generated
	 */
	EReference getOpenWorkloadType_InterArrivalTime();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.ClosedWorkloadType <em>Closed Workload Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Closed Workload Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.ClosedWorkloadType
	 * @generated
	 */
	EClass getClosedWorkloadType();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.usageprofile.ClosedWorkloadType#getPopulation <em>Population</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Population</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.ClosedWorkloadType#getPopulation()
	 * @see #getClosedWorkloadType()
	 * @generated
	 */
	EAttribute getClosedWorkloadType_Population();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.ClosedWorkloadType#getThinkTime <em>Think Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Think Time</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.ClosedWorkloadType#getThinkTime()
	 * @see #getClosedWorkloadType()
	 * @generated
	 */
	EReference getClosedWorkloadType_ThinkTime();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.AbstractUserAction <em>Abstract User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.AbstractUserAction
	 * @generated
	 */
	EClass getAbstractUserAction();

	/**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.usageprofile.AbstractUserAction#getParentScenarioBehavior <em>Parent Scenario Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Scenario Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.AbstractUserAction#getParentScenarioBehavior()
	 * @see #getAbstractUserAction()
	 * @generated
	 */
	EReference getAbstractUserAction_ParentScenarioBehavior();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.LoopUserAction <em>Loop User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.LoopUserAction
	 * @generated
	 */
	EClass getLoopUserAction();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.LoopUserAction#getLoopBodyScenarioBehavior <em>Loop Body Scenario Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Loop Body Scenario Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.LoopUserAction#getLoopBodyScenarioBehavior()
	 * @see #getLoopUserAction()
	 * @generated
	 */
	EReference getLoopUserAction_LoopBodyScenarioBehavior();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.LoopUserAction#getLoopIterationCount <em>Loop Iteration Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Loop Iteration Count</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.LoopUserAction#getLoopIterationCount()
	 * @see #getLoopUserAction()
	 * @generated
	 */
	EReference getLoopUserAction_LoopIterationCount();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.DelayUserAction <em>Delay User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Delay User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.DelayUserAction
	 * @generated
	 */
	EClass getDelayUserAction();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.DelayUserAction#getDelay <em>Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delay</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.DelayUserAction#getDelay()
	 * @see #getDelayUserAction()
	 * @generated
	 */
	EReference getDelayUserAction_Delay();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction <em>Branch User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Branch User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction
	 * @generated
	 */
	EClass getBranchUserAction();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction#getBranches <em>Branches</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Branches</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction#getBranches()
	 * @see #getBranchUserAction()
	 * @generated
	 */
	EReference getBranchUserAction_Branches();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction#getBranchingProbabilities <em>Branching Probabilities</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Branching Probabilities</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction#getBranchingProbabilities()
	 * @see #getBranchUserAction()
	 * @generated
	 */
	EReference getBranchUserAction_BranchingProbabilities();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction <em>System Call User Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Call User Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction
	 * @generated
	 */
	EClass getSystemCallUserAction();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction#getProvidingRole <em>Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Providing Role</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction#getProvidingRole()
	 * @see #getSystemCallUserAction()
	 * @generated
	 */
	EReference getSystemCallUserAction_ProvidingRole();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction#getSignature <em>Signature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Signature</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction#getSignature()
	 * @see #getSystemCallUserAction()
	 * @generated
	 */
	EReference getSystemCallUserAction_Signature();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction#getInputParameterSettings <em>Input Parameter Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Input Parameter Settings</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction#getInputParameterSettings()
	 * @see #getSystemCallUserAction()
	 * @generated
	 */
	EReference getSystemCallUserAction_InputParameterSettings();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting <em>Call Parameter Setting</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Parameter Setting</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting
	 * @generated
	 */
	EClass getCallParameterSetting();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting#getName()
	 * @see #getCallParameterSetting()
	 * @generated
	 */
	EAttribute getCallParameterSetting_Name();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting#getCharacterization <em>Characterization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Characterization</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting#getCharacterization()
	 * @see #getCallParameterSetting()
	 * @generated
	 */
	EAttribute getCallParameterSetting_Characterization();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting#getValue()
	 * @see #getCallParameterSetting()
	 * @generated
	 */
	EReference getCallParameterSetting_Value();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	UsageProfileFactory getUsageProfileFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfileImpl <em>Usage Profile</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfileImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getUsageProfile()
		 * @generated
		 */
		EClass USAGE_PROFILE = eINSTANCE.getUsageProfile();

		/**
		 * The meta object literal for the '<em><b>Imports</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_PROFILE__IMPORTS = eINSTANCE.getUsageProfile_Imports();

		/**
		 * The meta object literal for the '<em><b>System</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_PROFILE__SYSTEM = eINSTANCE.getUsageProfile_System();

		/**
		 * The meta object literal for the '<em><b>Usage Scenarios</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_PROFILE__USAGE_SCENARIOS = eINSTANCE.getUsageProfile_UsageScenarios();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.UsageScenarioImpl <em>Usage Scenario</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageScenarioImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getUsageScenario()
		 * @generated
		 */
		EClass USAGE_SCENARIO = eINSTANCE.getUsageScenario();

		/**
		 * The meta object literal for the '<em><b>Usage Model</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_SCENARIO__USAGE_MODEL = eINSTANCE.getUsageScenario_UsageModel();

		/**
		 * The meta object literal for the '<em><b>Scenario Behavior</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_SCENARIO__SCENARIO_BEHAVIOR = eINSTANCE.getUsageScenario_ScenarioBehavior();

		/**
		 * The meta object literal for the '<em><b>Workload Type</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference USAGE_SCENARIO__WORKLOAD_TYPE = eINSTANCE.getUsageScenario_WorkloadType();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.ScenarioBehaviorImpl <em>Scenario Behavior</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.ScenarioBehaviorImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getScenarioBehavior()
		 * @generated
		 */
		EClass SCENARIO_BEHAVIOR = eINSTANCE.getScenarioBehavior();

		/**
		 * The meta object literal for the '<em><b>Actions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCENARIO_BEHAVIOR__ACTIONS = eINSTANCE.getScenarioBehavior_Actions();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.WorkloadTypeImpl <em>Workload Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.WorkloadTypeImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getWorkloadType()
		 * @generated
		 */
		EClass WORKLOAD_TYPE = eINSTANCE.getWorkloadType();

		/**
		 * The meta object literal for the '<em><b>Usage Scenario</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference WORKLOAD_TYPE__USAGE_SCENARIO = eINSTANCE.getWorkloadType_UsageScenario();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.ImportImpl <em>Import</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.ImportImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getImport()
		 * @generated
		 */
		EClass IMPORT = eINSTANCE.getImport();

		/**
		 * The meta object literal for the '<em><b>Import URI</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute IMPORT__IMPORT_URI = eINSTANCE.getImport_ImportURI();

		/**
		 * The meta object literal for the '<em><b>Usageprofile</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IMPORT__USAGEPROFILE = eINSTANCE.getImport_Usageprofile();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.OpenWorkloadTypeImpl <em>Open Workload Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.OpenWorkloadTypeImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getOpenWorkloadType()
		 * @generated
		 */
		EClass OPEN_WORKLOAD_TYPE = eINSTANCE.getOpenWorkloadType();

		/**
		 * The meta object literal for the '<em><b>Inter Arrival Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME = eINSTANCE.getOpenWorkloadType_InterArrivalTime();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.ClosedWorkloadTypeImpl <em>Closed Workload Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.ClosedWorkloadTypeImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getClosedWorkloadType()
		 * @generated
		 */
		EClass CLOSED_WORKLOAD_TYPE = eINSTANCE.getClosedWorkloadType();

		/**
		 * The meta object literal for the '<em><b>Population</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CLOSED_WORKLOAD_TYPE__POPULATION = eINSTANCE.getClosedWorkloadType_Population();

		/**
		 * The meta object literal for the '<em><b>Think Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CLOSED_WORKLOAD_TYPE__THINK_TIME = eINSTANCE.getClosedWorkloadType_ThinkTime();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.AbstractUserActionImpl <em>Abstract User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.AbstractUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getAbstractUserAction()
		 * @generated
		 */
		EClass ABSTRACT_USER_ACTION = eINSTANCE.getAbstractUserAction();

		/**
		 * The meta object literal for the '<em><b>Parent Scenario Behavior</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR = eINSTANCE.getAbstractUserAction_ParentScenarioBehavior();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.LoopUserActionImpl <em>Loop User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.LoopUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getLoopUserAction()
		 * @generated
		 */
		EClass LOOP_USER_ACTION = eINSTANCE.getLoopUserAction();

		/**
		 * The meta object literal for the '<em><b>Loop Body Scenario Behavior</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR = eINSTANCE.getLoopUserAction_LoopBodyScenarioBehavior();

		/**
		 * The meta object literal for the '<em><b>Loop Iteration Count</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOOP_USER_ACTION__LOOP_ITERATION_COUNT = eINSTANCE.getLoopUserAction_LoopIterationCount();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.DelayUserActionImpl <em>Delay User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.DelayUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getDelayUserAction()
		 * @generated
		 */
		EClass DELAY_USER_ACTION = eINSTANCE.getDelayUserAction();

		/**
		 * The meta object literal for the '<em><b>Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DELAY_USER_ACTION__DELAY = eINSTANCE.getDelayUserAction_Delay();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.BranchUserActionImpl <em>Branch User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.BranchUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getBranchUserAction()
		 * @generated
		 */
		EClass BRANCH_USER_ACTION = eINSTANCE.getBranchUserAction();

		/**
		 * The meta object literal for the '<em><b>Branches</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCH_USER_ACTION__BRANCHES = eINSTANCE.getBranchUserAction_Branches();

		/**
		 * The meta object literal for the '<em><b>Branching Probabilities</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BRANCH_USER_ACTION__BRANCHING_PROBABILITIES = eINSTANCE.getBranchUserAction_BranchingProbabilities();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl <em>System Call User Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getSystemCallUserAction()
		 * @generated
		 */
		EClass SYSTEM_CALL_USER_ACTION = eINSTANCE.getSystemCallUserAction();

		/**
		 * The meta object literal for the '<em><b>Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE = eINSTANCE.getSystemCallUserAction_ProvidingRole();

		/**
		 * The meta object literal for the '<em><b>Signature</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SYSTEM_CALL_USER_ACTION__SIGNATURE = eINSTANCE.getSystemCallUserAction_Signature();

		/**
		 * The meta object literal for the '<em><b>Input Parameter Settings</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS = eINSTANCE.getSystemCallUserAction_InputParameterSettings();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.usageprofile.impl.CallParameterSettingImpl <em>Call Parameter Setting</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.CallParameterSettingImpl
		 * @see edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfilePackageImpl#getCallParameterSetting()
		 * @generated
		 */
		EClass CALL_PARAMETER_SETTING = eINSTANCE.getCallParameterSetting();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL_PARAMETER_SETTING__NAME = eINSTANCE.getCallParameterSetting_Name();

		/**
		 * The meta object literal for the '<em><b>Characterization</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL_PARAMETER_SETTING__CHARACTERIZATION = eINSTANCE.getCallParameterSetting_Characterization();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL_PARAMETER_SETTING__VALUE = eINSTANCE.getCallParameterSetting_Value();

	}

} //UsageProfilePackage
