/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;

import edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior;
import edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Branch User Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.BranchUserActionImpl#getBranches <em>Branches</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.BranchUserActionImpl#getBranchingProbabilities <em>Branching Probabilities</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BranchUserActionImpl extends AbstractUserActionImpl implements BranchUserAction {
	/**
	 * The cached value of the '{@link #getBranches() <em>Branches</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBranches()
	 * @generated
	 * @ordered
	 */
	protected EList<ScenarioBehavior> branches;

	/**
	 * The cached value of the '{@link #getBranchingProbabilities() <em>Branching Probabilities</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBranchingProbabilities()
	 * @generated
	 * @ordered
	 */
	protected RandomVariable branchingProbabilities;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BranchUserActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return UsageProfilePackage.Literals.BRANCH_USER_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ScenarioBehavior> getBranches() {
		if (branches == null) {
			branches = new EObjectContainmentEList<ScenarioBehavior>(ScenarioBehavior.class, this, UsageProfilePackage.BRANCH_USER_ACTION__BRANCHES);
		}
		return branches;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomVariable getBranchingProbabilities() {
		return branchingProbabilities;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBranchingProbabilities(RandomVariable newBranchingProbabilities, NotificationChain msgs) {
		RandomVariable oldBranchingProbabilities = branchingProbabilities;
		branchingProbabilities = newBranchingProbabilities;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES, oldBranchingProbabilities, newBranchingProbabilities);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBranchingProbabilities(RandomVariable newBranchingProbabilities) {
		if (newBranchingProbabilities != branchingProbabilities) {
			NotificationChain msgs = null;
			if (branchingProbabilities != null)
				msgs = ((InternalEObject)branchingProbabilities).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES, null, msgs);
			if (newBranchingProbabilities != null)
				msgs = ((InternalEObject)newBranchingProbabilities).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES, null, msgs);
			msgs = basicSetBranchingProbabilities(newBranchingProbabilities, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES, newBranchingProbabilities, newBranchingProbabilities));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHES:
				return ((InternalEList<?>)getBranches()).basicRemove(otherEnd, msgs);
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES:
				return basicSetBranchingProbabilities(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHES:
				return getBranches();
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES:
				return getBranchingProbabilities();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHES:
				getBranches().clear();
				getBranches().addAll((Collection<? extends ScenarioBehavior>)newValue);
				return;
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES:
				setBranchingProbabilities((RandomVariable)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHES:
				getBranches().clear();
				return;
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES:
				setBranchingProbabilities((RandomVariable)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHES:
				return branches != null && !branches.isEmpty();
			case UsageProfilePackage.BRANCH_USER_ACTION__BRANCHING_PROBABILITIES:
				return branchingProbabilities != null;
		}
		return super.eIsSet(featureID);
	}

} //BranchUserActionImpl
