/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;

import edu.kit.ipd.descartes.mm.usageprofile.ClosedWorkloadType;
import edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage;

import java.math.BigInteger;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Closed Workload Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.ClosedWorkloadTypeImpl#getPopulation <em>Population</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.ClosedWorkloadTypeImpl#getThinkTime <em>Think Time</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ClosedWorkloadTypeImpl extends WorkloadTypeImpl implements ClosedWorkloadType {
	/**
	 * The default value of the '{@link #getPopulation() <em>Population</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPopulation()
	 * @generated
	 * @ordered
	 */
	protected static final BigInteger POPULATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPopulation() <em>Population</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPopulation()
	 * @generated
	 * @ordered
	 */
	protected BigInteger population = POPULATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getThinkTime() <em>Think Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getThinkTime()
	 * @generated
	 * @ordered
	 */
	protected RandomVariable thinkTime;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClosedWorkloadTypeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return UsageProfilePackage.Literals.CLOSED_WORKLOAD_TYPE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BigInteger getPopulation() {
		return population;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPopulation(BigInteger newPopulation) {
		BigInteger oldPopulation = population;
		population = newPopulation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.CLOSED_WORKLOAD_TYPE__POPULATION, oldPopulation, population));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomVariable getThinkTime() {
		return thinkTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetThinkTime(RandomVariable newThinkTime, NotificationChain msgs) {
		RandomVariable oldThinkTime = thinkTime;
		thinkTime = newThinkTime;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME, oldThinkTime, newThinkTime);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setThinkTime(RandomVariable newThinkTime) {
		if (newThinkTime != thinkTime) {
			NotificationChain msgs = null;
			if (thinkTime != null)
				msgs = ((InternalEObject)thinkTime).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME, null, msgs);
			if (newThinkTime != null)
				msgs = ((InternalEObject)newThinkTime).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME, null, msgs);
			msgs = basicSetThinkTime(newThinkTime, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME, newThinkTime, newThinkTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME:
				return basicSetThinkTime(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__POPULATION:
				return getPopulation();
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME:
				return getThinkTime();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__POPULATION:
				setPopulation((BigInteger)newValue);
				return;
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME:
				setThinkTime((RandomVariable)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__POPULATION:
				setPopulation(POPULATION_EDEFAULT);
				return;
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME:
				setThinkTime((RandomVariable)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__POPULATION:
				return POPULATION_EDEFAULT == null ? population != null : !POPULATION_EDEFAULT.equals(population);
			case UsageProfilePackage.CLOSED_WORKLOAD_TYPE__THINK_TIME:
				return thinkTime != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (population: ");
		result.append(population);
		result.append(')');
		return result.toString();
	}

} //ClosedWorkloadTypeImpl
