/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature;

import edu.kit.ipd.descartes.mm.usageprofile.AbstractUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting;
import edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior;
import edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>System Call User Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getParentScenarioBehavior <em>Parent Scenario Behavior</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getProvidingRole <em>Providing Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getSignature <em>Signature</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getInputParameterSettings <em>Input Parameter Settings</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SystemCallUserActionImpl extends EntityImpl implements SystemCallUserAction {
	/**
	 * The cached value of the '{@link #getProvidingRole() <em>Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvidingRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceProvidingRole providingRole;

	/**
	 * The cached value of the '{@link #getSignature() <em>Signature</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSignature()
	 * @generated
	 * @ordered
	 */
	protected Signature signature;

	/**
	 * The cached value of the '{@link #getInputParameterSettings() <em>Input Parameter Settings</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInputParameterSettings()
	 * @generated
	 * @ordered
	 */
	protected EList<CallParameterSetting> inputParameterSettings;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SystemCallUserActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return UsageProfilePackage.Literals.SYSTEM_CALL_USER_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScenarioBehavior getParentScenarioBehavior() {
		if (eContainerFeatureID() != UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR) return null;
		return (ScenarioBehavior)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetParentScenarioBehavior(ScenarioBehavior newParentScenarioBehavior, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newParentScenarioBehavior, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentScenarioBehavior(ScenarioBehavior newParentScenarioBehavior) {
		if (newParentScenarioBehavior != eInternalContainer() || (eContainerFeatureID() != UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR && newParentScenarioBehavior != null)) {
			if (EcoreUtil.isAncestor(this, newParentScenarioBehavior))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newParentScenarioBehavior != null)
				msgs = ((InternalEObject)newParentScenarioBehavior).eInverseAdd(this, UsageProfilePackage.SCENARIO_BEHAVIOR__ACTIONS, ScenarioBehavior.class, msgs);
			msgs = basicSetParentScenarioBehavior(newParentScenarioBehavior, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR, newParentScenarioBehavior, newParentScenarioBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole getProvidingRole() {
		if (providingRole != null && providingRole.eIsProxy()) {
			InternalEObject oldProvidingRole = (InternalEObject)providingRole;
			providingRole = (InterfaceProvidingRole)eResolveProxy(oldProvidingRole);
			if (providingRole != oldProvidingRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE, oldProvidingRole, providingRole));
			}
		}
		return providingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole basicGetProvidingRole() {
		return providingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProvidingRole(InterfaceProvidingRole newProvidingRole) {
		InterfaceProvidingRole oldProvidingRole = providingRole;
		providingRole = newProvidingRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE, oldProvidingRole, providingRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signature getSignature() {
		if (signature != null && signature.eIsProxy()) {
			InternalEObject oldSignature = (InternalEObject)signature;
			signature = (Signature)eResolveProxy(oldSignature);
			if (signature != oldSignature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE, oldSignature, signature));
			}
		}
		return signature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signature basicGetSignature() {
		return signature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSignature(Signature newSignature) {
		Signature oldSignature = signature;
		signature = newSignature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE, oldSignature, signature));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CallParameterSetting> getInputParameterSettings() {
		if (inputParameterSettings == null) {
			inputParameterSettings = new EObjectContainmentEList<CallParameterSetting>(CallParameterSetting.class, this, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS);
		}
		return inputParameterSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetParentScenarioBehavior((ScenarioBehavior)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR:
				return basicSetParentScenarioBehavior(null, msgs);
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				return ((InternalEList<?>)getInputParameterSettings()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR:
				return eInternalContainer().eInverseRemove(this, UsageProfilePackage.SCENARIO_BEHAVIOR__ACTIONS, ScenarioBehavior.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR:
				return getParentScenarioBehavior();
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE:
				if (resolve) return getProvidingRole();
				return basicGetProvidingRole();
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE:
				if (resolve) return getSignature();
				return basicGetSignature();
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				return getInputParameterSettings();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR:
				setParentScenarioBehavior((ScenarioBehavior)newValue);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE:
				setProvidingRole((InterfaceProvidingRole)newValue);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE:
				setSignature((Signature)newValue);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				getInputParameterSettings().clear();
				getInputParameterSettings().addAll((Collection<? extends CallParameterSetting>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR:
				setParentScenarioBehavior((ScenarioBehavior)null);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE:
				setProvidingRole((InterfaceProvidingRole)null);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE:
				setSignature((Signature)null);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				getInputParameterSettings().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR:
				return getParentScenarioBehavior() != null;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE:
				return providingRole != null;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE:
				return signature != null;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				return inputParameterSettings != null && !inputParameterSettings.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == AbstractUserAction.class) {
			switch (derivedFeatureID) {
				case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR: return UsageProfilePackage.ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == AbstractUserAction.class) {
			switch (baseFeatureID) {
				case UsageProfilePackage.ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR: return UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PARENT_SCENARIO_BEHAVIOR;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} //SystemCallUserActionImpl
